local core = require ( "core" )
local Deck = require ( "Loaders.Deck" )

local loader = core.class ( Deck )

function loader.defaultInstance ()
    return MOAIGfxQuad2D.new ()
end

function loader:loadRect ( instance, val, context )
    instance:setRect( unpack ( val ))
end

function loader:loadUVRect ( instance, val, context )
    instance:setUVRect ( unpack ( val ))
end

function loader:loadBounds ( instance, val, context )
    local x0, y0, x1, y1 = unpack ( val )
    local bounds = MOAIBoundsDeck.new ()
    bounds:reserveBounds ( 1 )
    bounds:reserveIndices ( 1 )
    bounds:setBounds ( 1, x0, y0, -1, x1, y1, 1 )
    bounds:setIndex ( 1, 1 )
    instance:setBoundsDeck ( bounds )
end

return loader

