local core = require ( "core" )
local GfxQuad = require ( "Loaders.GfxQuad" )

local loader = core.class ( GfxQuad )

loader:systemKey "reserve"

function loader.defaultInstance ( cfg )
    instance = MOAIGfxQuadDeck2D.new ()
    if cfg.reserve then
        instance:reserve ( cfg.reserve )
    end
    return instance
end

function loader:loadRects ( instance, val, context )
    for i, r in ipairs(val) do
        instance:setRect ( i, unpack ( r ))
    end
end

function loader:loadUVRects ( instance, val, context )
    for i, r in ipairs(val) do
        instance:setUVRect ( i, unpack ( r ))
    end
end

return loader

