local core = require ( "core" )
local Transform = require ( "Loaders.Transform" )

local loader = core.class ( Transform )

function loader.defaultInstance ( cfg )
    return MOAIProp2D.new ()
end

function loader:loadLayer ( instance, val, context )
    context [ val ]:insertProp ( instance )
end

function loader:loadDeck ( instance, val, context )
    instance:setDeck ( self.tablePathCheck( val, context ))
end

function loader:loadPartition ( instance, val, context )
    self.tablePathCheck( val, context ):insertProp ( instance )
end

function loader:loadBlendMode ( instance, val, context )
    instance:setBlendMode ( unpack ( val ))
end

function loader:loadColor ( instance, val, context )
    instance:setColor ( unpack ( val ))
end

return loader
