local core = require ( "core" )
local Deck = require ( "Loaders.Deck" )

local loader = core.class ( Deck )

function loader.defaultInstance ()
    return MOAIStretchPatch2D.new ()
end

function loader:loadRect ( instance, val, context )
    instance:setRect( unpack ( val ))
end

function loader:loadUVRects ( instance, val, context )
    local n = #val
    instance:reserveUVRects ( n )
    for i = 1, n do
        instance:setUVRect ( i, unpack ( val [ i ]))
    end
end

function loader:loadRows ( instance, val, context )
    local n = #val
    instance:reserveRows ( n )
    for i = 1, n do
        instance:setRow ( i, unpack ( val [ i ]))
    end
end

function loader:loadColumns ( instance, val, context )
    local n = #val
    instance:reserveColumns ( n )
    for i = 1, n do
        instance:setColumn ( i, unpack ( val [ i ]))
    end
end

return loader

