local core = require ( "core" )
local Prop = require ( "Loaders.Prop" )

local Resources = require ( "Resources" )

local loader = core.class ( Prop )

function loader.defaultInstance ( cfg )
    local instance = MOAITextBox.new ()
    instance:setShader ( MOAIShaderMgr.getShader ( MOAIShaderMgr.DECK2D_SHADER ))
    return instance
end

function loader:loadRect ( instance, val, context )
    instance:setRect ( unpack ( val ))
end

function loader:loadAlignment ( instance, val, context )
    instance:setAlignment ( unpack ( val ))
end

function loader:loadFont ( instance, val, context )
    local style = instance:getStyle ()
    if not style then
        style = MOAITextStyle.new ()
    end
    style:setFont ( Resources.fontCache:get ( val ))
    instance:setStyle ( style )
end

function loader:loadTextSize ( instance, val, context )
    local style = instance:getStyle ()
    if not style then
        style = MOAITextStyle.new ()
    end
    style:setSize ( val )
    instance:setStyle ( style )
end

function loader:loadTextColor ( instance, val, context )
    local style = instance:getStyle ()
    if not style then
        style = MOAITextStyle.new ()
    end
    style:setColor ( unpack ( val ))
    instance:setStyle ( style )
end


return loader
