local core = require ( "core" )

local Resources = require ( "Resources" )

local SoundManager = core.class ( Object )
{
    DEFAULT_VOLUME = 1.0,
    DEFAULT_SAMPLE_RATE = 22050,
    SOUND_PATH = "Resources/Sounds/"
}

local function _playUntz ( file, volume )
    local sound = Resources.soundCache:get ( SoundManager.SOUND_PATH .. file )
    if sound then
        local volume = volume or SoundManager.DEFAULT_VOLUME
        sound:setVolume ( volume )
        sound:play ()
    end
    return sound
end

local function _playHIAudio ( file, volume )
    local snd = MOAIHiAudioSound.new ()
    local volume = volume or SoundManager.DEFAULT_VOLUME
    snd:setVolume ( volume )
    snd:load ( SoundManager.SOUND_PATH .. file )
    snd:play ()
end

local function _dummy ( file, volume )
end

function SoundManager.init ( sampleRate, volume )
    if MOAIHiAudioSound then
        SoundManager.play = _playHIAudio
    elseif MOAIUntzSystem then
        MOAIUntzSystem.initialize ( sampleRate or SoundManager.DEFAULT_SAMPLE_RATE )
        MOAIUntzSystem.setVolume ( volume or SoundManager.DEFAULT_VOLUME )
        SoundManager.play = _playUntz
    else
        SoundManager.play = _dummy
    end
end

return SoundManager
