local _NAME = ...
local core = require ( "core" )

local Events = require ( "Events" )

local InfoScreen = core.class ( Object )

function InfoScreen:ctor ( viewport )
    self.viewport = viewport
    local resource = require ( _NAME .. ".resources" )
    for _, res in pairs ( resource ) do
        res:create ( self )
    end
    
    local i = 1
    local label = self [ "label_" .. i ]
    local labels = {}
    while label do
        labels [ #labels + 1 ] = label
        i = i + 1
        label = self [ "label_" .. i ]
    end
    self._labels = label
    
    app.queue:subscribe ( self, InfoScreen.handleTap, Events.E_GAME.DEFAULT_TAP )
end

function InfoScreen:handleTap ()
    app.queue:unsubscribe ( self, InfoScreen.handleTap, Events.E_GAME.DEFAULT_TAP )
    app.queue:postEvent ( nil, Events.E_GAME.HIDE_INFO )
end

return InfoScreen
