av = {}

local defaults =
{
    sampleRate = 16000,
    volume = 1.0,
}

function av:init ( options )
    if MOAIHiAudioSound then
        log ( "Use MOAIHiAudioSound" )
        self._soundsCache = ResourceCache.new (
            function ( filename )
                local snd = MOAIHiAudioSound.new ()
                snd:load ( filename )
                return snd
            end
        )
    -- elseif MOAIUntzSystem then
    --     log ( "Use MOAIUntzSystem" )
    --     MOAIUntzSystem.initialize ( options.sampleRate or defaults.sampleRate )
    --     MOAIUntzSystem.setVolume ( options.volume or defaults.volume )

    --     self._soundsCache = ResourceCache.new (
    --         function ( filename )
    --             local snd = MOAIUntzSound.new ()
    --             snd:load ( filename )
    --             return snd
    --         end
    --     )
    else
        log ( "No sound available" )
        self.playSound = function ( )
            -- do nothing
        end;
    end

end

function av:getSound ( filename )
    if self._soundsCache then
        return self._soundsCache:get ( filename )
    end
end

function av:playSound ( filename, volume )
    if self._soundsCache then
        local snd = self._soundsCache:get ( filename )
        if snd then
            snd:setVolume ( volume or 1.0 )
            snd:play ()
			return snd
        end
    end
end
