GAME_NAME = "Spin & Dare"

DESIGN_W, DESIGN_H = 640, 960
SCREEN_W, SCREEN_H = MOAIGfxDevice.getViewSize ()
SCREEN_W, SCREEN_H = SCREEN_W or 0, SCREEN_H or 0

if SCREEN_W == 0 or SCREEN_H == 0 then
    SCREEN_W, SCREEN_H = 320, 480
    -- SCREEN_W, SCREEN_H = 320, 568 -- iphone 5
    -- SCREEN_W, SCREEN_H = 768, 1024 -- ipad
end

MODEL_SCREEN_W, MODEL_SCREEN_H = SCREEN_W, SCREEN_H

do
    local scaleX, scaleY = DESIGN_W / SCREEN_W, DESIGN_H / SCREEN_H
    local scale = math.max ( scaleX, scaleY )
    MODEL_SCREEN_W, MODEL_SCREEN_H = scale * SCREEN_W, scale * SCREEN_H 
end

-- library
require "lib.core"
require "lib.gui"
require "lib.av"

-- model
require "src.model.Model"

-- views
require "src.view.widgets.DialogButton"
require "src.view.widgets.ResultButton"
require "src.view.WheelView"
require "src.view.DlgHelp"
require "src.view.DlgExit"
require "src.view.DlgCamera"
require "src.view.ScrSplash"
require "src.view.GameView"

-- controller
require "src.controller.CameraCtrl"
require "src.controller.LocalPlayer"
require "src.controller.AppCtrl"

-- load resources
require "res.resources"

local function setupViewport ()
    MOAISim.openWindow ( GAME_NAME, SCREEN_W, SCREEN_H )

    local viewport =  MOAIViewport.new ()
    viewport:setSize ( SCREEN_W, SCREEN_H )
    viewport:setScale ( MODEL_SCREEN_W, MODEL_SCREEN_H )

    -- MOAIGfxDevice.setListener ( MOAIGfxDevice.EVENT_RESIZE,
    --     function ( width, height )
    --     end
    -- )
    return viewport
end

function math.sign ( x )
    return x > 0 and 1 or x < 0 and -1 or 0
end

function main ()
    local viewport = setupViewport ()
    gui:init ( viewport )
    av:init
    {
        sampleRate = 16000;
    }

    local controller = AppCtrl.new ()

    app.queue:postEvent ( nil, E_SYSTEM.START, { })
end

main ()

