gui:loadSpriteSheet ( "art.textures.ui" )
gui:loadSpriteSheet ( "art.textures.smiles" )

function makeBG ( fill )
	local rsrc = rm:rsrc ( gui.Widget, "/background" ) 
	{
		x = -0.5 * MODEL_SCREEN_W, y = -0.5 * MODEL_SCREEN_H;
		
		deck = rm:rsrc ( gui.TileDeck ) 
		{ 
			texture = "art/textures/bg.png";
			rows = 1, cols = 1;
		},
		
		grid = rm:rsrc ( gui.RectGrid ) 
		{ 
			tileWidth = 37.0, tileHeight = 37.0;
			width = math.ceil ( MODEL_SCREEN_W / 37.0 );
			height = math.ceil ( MODEL_SCREEN_H / 37.0 );
			fill = fill;
		}
	}
	
    return rsrc
end

rm.RSRC_ACTION_RATE = rm:rsrc ( gui.Widget )
{	
	x = 0, y = - 397.0 / 2.0;

	rm:rsrc ( gui.Widget, "/background" )
	{	
		x = 0, y = 0.5 * MODEL_SCREEN_H - 397.0 / 2.0;
		color = { 0.0, 0.0, 0.0, 0.7 };
		-- blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA };
		
		deck = rm:rsrc ( gui.GfxQuad )
		{
			sprite = "bg_white.png";
			scaleX = 3.0, scaleY = 2.0;
			alignX = 0, alignY = 1;
		};
	},
	
	rm:rsrc ( gui.TextBox, "/text" )
	{
		x = 0, y = 0;
		color = { 1.0, 1.0, 1.0 };
		font = "art/fonts/arial_round.fnt",
		fontSize = 75;
		rect = { -300, -300, 300, 300 };
		-- shader = MOAIShaderMgr.getShader ( MOAIShaderMgr.DECK2D_SHADER );
	},	
	
	rm:rsrc ( ResultButton, "/btnBad" )
	{
		id = "GameView.Bad";
		x = 0.5 * MODEL_SCREEN_W - 63;
		y = - MODEL_SCREEN_H / 2.0 + 397.0 / 2.0 + 60;
		 
		deck = rm:rsrc ( gui.GfxQuadListDeck )
		{
			[ gui.Button.REGULAR ] =
			{
				{ sprite = "smile_bad.png"; x = 0, y = 0; alignX = 0, alignY = 0; scaleX = 0.5, scaleY = 0.5; },
				{ sprite = "smile_mouth.png"; x = 0, y = -5; alignX = 0, alignY = 1; scaleX = 0.5, scaleY = 0.5; },
				{ sprite = "smile_eye_left.png"; x = -7, y = 11; alignX = 1, alignY = 0; scaleX = 0.5, scaleY = 0.5; },
				{ sprite = "smile_eye_right.png"; x = 7, y = 11; alignX = -1, alignY = 0; scaleX = 0.5, scaleY = 0.5; },
				{ sprite = "smile_brow_left.png"; x = -7, y = 32; alignX = 1, alignY = 0; scaleX = 0.5, scaleY = 0.5;  },
				{ sprite = "smile_brow_right.png"; x = 7, y = 32; alignX = -1, alignY = 0; scaleX = 0.5, scaleY = 0.5; },				
			},                                                      

			[ gui.Button.PRESSED ] =
			{
				{ sprite = "smile_bad.png"; x = 0, y = 0; alignX = 0, alignY = 0; scaleX = 0.475, scaleY = 0.475; },
				{ sprite = "smile_mouth.png"; x = 0, y = -4.5; alignX = 0, alignY = 1; scaleX = 0.475, scaleY = 0.475; },
				{ sprite = "smile_eye_left.png"; x = -6.5, y = 10; alignX = 1, alignY = 0; scaleX = 0.475, scaleY = 0.475; },
				{ sprite = "smile_eye_right.png"; x = 6.5, y = 10; alignX = -1, alignY = 0; scaleX = 0.475, scaleY = 0.475; },
				{ sprite = "smile_brow_left.png"; x = -6.5, y = 30; alignX = 1, alignY = 0; scaleX = 0.475, scaleY = 0.475; },
				{ sprite = "smile_brow_right.png"; x = 6.5, y = 30; alignX = -1, alignY = 0; scaleX = 0.475, scaleY = 0.475; },				
			},
		};
	},
		
	rm:rsrc ( ResultButton, "/btnGood" )
	{
		id = "GameView.Good";
		x = -0.5 * MODEL_SCREEN_W + 62;	
		y = - MODEL_SCREEN_H / 2.0 + 397.0 / 2.0 + 60;
		
		deck = rm:rsrc ( gui.GfxQuadListDeck )
		{
			[ gui.Button.REGULAR ] =
			{
				{ sprite = "smile_good.png"; x = 0, y = 0; alignX = 0, alignY = 0; scaleX = 0.5, scaleY = 0.5; },
				{ sprite = "smile_mouth.png"; x = 0, y = -7; alignX = 0, alignY = -1; scaleX = 0.5, scaleY = -0.5; },
				{ sprite = "smile_eye_left.png"; x = -7, y = 11; alignX = 1, alignY = 0; scaleX = 0.5, scaleY = 0.5; },
				{ sprite = "smile_eye_right.png"; x = 7, y = 11; alignX = -1, alignY = 0; scaleX = 0.5, scaleY = 0.5; },
				{ sprite = "smile_brow_right.png"; x = -8, y = 32; alignX = 1, alignY = 0; scaleX = 0.5, scaleY = 0.5; },
				{ sprite = "smile_brow_left.png"; x = 8, y = 32; alignX = -1, alignY = 0; scaleX = 0.5, scaleY = 0.5; },				
			},

			[ gui.Button.PRESSED ] =
			{
				{ sprite = "smile_good.png"; x = 0, y = 0; alignX = 0, alignY = 0; scaleX = 0.475, scaleY = 0.475; },
				{ sprite = "smile_mouth.png"; x = 0, y = -6; alignX = 0, alignY = -1; scaleX = 0.475, scaleY = -0.475; },
				{ sprite = "smile_eye_left.png"; x = -6.5, y = 11; alignX = 1, alignY = 0; scaleX = 0.475, scaleY = 0.475; },
				{ sprite = "smile_eye_right.png"; x = 6.5, y = 11; alignX = -1, alignY = 0; scaleX = 0.475, scaleY = 0.475; },
				{ sprite = "smile_brow_right.png"; x = -8.5, y = 30; alignX = 1, alignY = 0; scaleX = 0.475, scaleY = 0.475; },
				{ sprite = "smile_brow_left.png"; x = 8.5, y = 30; alignX = -1, alignY = 0; scaleX = 0.475, scaleY = 0.475; },								
			},
		};
	},
}
	
rm.RSRC_ACTION_PERFORM = rm:rsrc ( gui.Widget )
{	
	x = 0, y = - 397.0 / 2.0;

	rm:rsrc ( gui.Widget, "/background" )
	{	
		x = 0, y = 0.5 * MODEL_SCREEN_H - 397.0 / 2.0;
		color = { 0.0, 0.0, 0.0, 0.7 };
		-- blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA };
		
		deck = rm:rsrc ( gui.GfxQuad )
		{
			sprite = "bg_white.png";
			scaleX = 3.0, scaleY = 2.0;
			alignX = 0, alignY = 1;
		};
	},
		
	rm:rsrc ( gui.Widget, "/smile" )
	{
		x = 0, y = -110;
	},
	
	rm:rsrc ( gui.Widget, "/timer" )
	{
		x = 0, y = -100;
		
		blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA };
		
        deck = rm:rsrc ( gui.GfxQuadDeck )
        {
            { sprite = "timer_1.png"; };
            { sprite = "timer_2.png"; };
			{ sprite = "timer_3.png"; };
        },
	},
	
	rm:rsrc ( gui.TextBox, "/perform" )
	{
		x = 0, y = -100;
		color = { 1.0, 1.0, 1.0 };
		font = "art/fonts/arial_round.fnt",
		fontSize = 75;
		rect = { -300, -300, 300, 300 };
		-- shader = MOAIShaderMgr.getShader ( MOAIShaderMgr.DECK2D_SHADER );
	},	
	
	rm:rsrc ( gui.TextBox, "/text" )
	{
		x = 0, y = 140;
		color = { 1.0, 1.0, 1.0 };
		font = "art/fonts/arial_round.fnt",
		fontSize = 75;
		rect = { -300, -300, 300, 300 };
		-- shader = MOAIShaderMgr.getShader ( MOAIShaderMgr.DECK2D_SHADER );
	},
}

rm.RSRC_RESULT_VIEW_BAD = rm:rsrc ( gui.Widget )
{
	x = 0, y = - 397.0 / 2.0;
	
	rm:rsrc ( gui.Widget, "/background" )
	{	
		x = 0, y = 0.5 * MODEL_SCREEN_H - 397.0 / 2.0;
		color = { 0.0, 0.0, 0.0, 0.7 };
		-- blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA };
		
		deck = rm:rsrc ( gui.GfxQuad )
		{
			sprite = "bg_white.png";
			scaleX = 3.0, scaleY = 2.0;
			alignX = 0, alignY = 1;
		};
	},
	
	rm:rsrc ( gui.Widget, "/smile" )
    {
		x = 0, y = 55;
		
		deck = rm:rsrc ( gui.GfxQuadListDeck )
		{
			{
				{ sprite = "smile_bad.png"; x = 0, y = 0; alignX = 0, alignY = 0; scaleX = 1.25, scaleY = 1.25; },
				{ sprite = "smile_mouth.png"; x = 0, y = -17; alignX = 0, alignY = 1; scaleX = 1.25, scaleY = 1.25; },
				{ sprite = "smile_eye_left.png"; x = -20, y = 33; alignX = 1, alignY = 0; scaleX = 1.25, scaleY = 1.25; },
				{ sprite = "smile_eye_right.png"; x = 20, y = 33; alignX = -1, alignY = 0; scaleX = 1.25, scaleY = 1.25; },
				{ sprite = "smile_brow_left.png"; x = -22, y = 90; alignX = 1, alignY = 0; scaleX = 1.25, scaleY = 1.25;  },
				{ sprite = "smile_brow_right.png"; x = 22, y = 90; alignX = -1, alignY = 0; scaleX = 1.25, scaleY = 1.25; },				
			},
		};
    }, 
	
	rm:rsrc ( gui.TextBox, "/text" )
	{
		x = 0, y = -190;
		color = { 1.0, 1.0, 1.0, 1.0 };
		font = "art/fonts/arial_round.fnt",
		fontSize = 75;
		rect = { -300, -300, 300, 300 };
	},
}

rm.RSRC_RESULT_VIEW_GOOD = rm:rsrc ( gui.Widget )
{
	x = 0, y = - 397.0 / 2.0;
	
	rm:rsrc ( gui.Widget, "/background" )
	{	
		x = 0, y = 0.5 * MODEL_SCREEN_H - 397.0 / 2.0;
		color = { 0.0, 0.0, 0.0, 0.7 };
		-- blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA };
		
		deck = rm:rsrc ( gui.GfxQuad )
		{
			sprite = "bg_white.png";
			scaleX = 3.0, scaleY = 2.0;
			alignX = 0, alignY = 1;
		};
	},
	
	rm:rsrc ( gui.Widget, "/smile" )
    {
		x = 0, y = 55;
		
		deck = rm:rsrc ( gui.GfxQuadListDeck )
		{
			{
				{ sprite = "smile_good.png"; x = 0, y = 0; alignX = 0, alignY = 0; scaleX = 1.25, scaleY = 1.25; },
				{ sprite = "smile_mouth.png"; x = 0, y = -21; alignX = 0, alignY = -1; scaleX = 1.25, scaleY = -1.25; },
				{ sprite = "smile_eye_left.png"; x = -20, y = 33; alignX = 1, alignY = 0; scaleX = 1.25, scaleY = 1.25; },
				{ sprite = "smile_eye_right.png"; x = 20, y = 33; alignX = -1, alignY = 0; scaleX = 1.25, scaleY = 1.25; },
				{ sprite = "smile_brow_right.png"; x = -25, y = 90; alignX = 1, alignY = 0; scaleX = 1.25, scaleY = 1.25; },
				{ sprite = "smile_brow_left.png"; x = 25, y = 90; alignX = -1, alignY = 0; scaleX = 1.25, scaleY = 1.25; },				
			},
		};
    },
	
	rm:rsrc ( gui.TextBox, "/text" )
	{
		x = 0, y = -190;
		color = { 1.0, 1.0, 1.0, 1.0 };
		font = "art/fonts/arial_round.fnt",
		fontSize = 85;
		rect = { -300, -300, 300, 300 };
	},		
}

rm.RSRC_POPUP = rm:rsrc ( gui.Widget )
{
	x = 0, y = - 0.5 * MODEL_SCREEN_H + 68.0;
	
	rm:rsrc ( gui.Widget, "/background" )
	{	
		x = 0, y = 68.0;
		color = { 0.0, 0.0, 0.0, 0.7 };
		blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA };
		
		deck = rm:rsrc ( gui.GfxQuad )
		{
			sprite = "bg_white.png";
			scaleX = 3.0, scaleY = 2.0;
			alignX = 0, alignY = 1;
		};
	},
	
	rm:rsrc ( gui.TextBox, "/text" )
	{
		x = 0, y = 0;
		color = { 1.0, 1.0, 1.0, 1.0 };
		font = "art/fonts/arial_round.fnt",
		fontSize = 55;
		rect = { -280, -30, 280, 30 };
	},		
}

rm.RSRC_GAME_VIEW = rm:rsrc ( gui.Widget )
{
    x = 0, y = 0;

	rm:rsrc ( gui.Widget, "/background" )
    {
        makeBG ( 1 ),
    },

    rm:rsrc ( gui.Widget, "/previewBackground" )
    {
		x = - 0.5 * MODEL_SCREEN_W + 5;
		y = 0.5 * MODEL_SCREEN_H - 7;

		rm:rsrc ( gui.Widget )
		{
			x = 312.0 / 2.0;
			y = -390.0;
			blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA };
			color = { 1.0, 1.0, 1.0, 0.35 };
			
			deck = rm:rsrc ( gui.GfxQuad )
			{
				sprite = "wheel_shadow.png";
				alignX = 0, alignY = 0;
				scaleX = 1.45, scaleY = 0.25;
			}
		},	
		
		rm:rsrc ( gui.Widget, "video" )
		{
		},
		
		rm:rsrc ( gui.Widget )
		{
			deck = rm:rsrc ( gui.GfxQuad )
			{
				sprite = "video_frame.png";
				alignX = -1, alignY = 1;
				scaleX = 1, scaleY = 1;
			}
		},
		
		rm:rsrc ( gui.TextBox, "text" )
		{
			x = 312.0 / 2.0;
			y = -390.0 / 2.0;
			font = "art/fonts/arial_round.fnt",
			color = { 0.0, 0.0, 0.0, 0.5 },
			fontSize = 40,
			rect = {-300, -300, 300, 300,},
		},		
    },

    rm:rsrc ( gui.Widget, "/playbackBackground" )
    {
		x = 0.5 * MODEL_SCREEN_W - 5;
		y = 0.5 * MODEL_SCREEN_H - 7;

		rm:rsrc ( gui.Widget )
		{
			x = -312.0 / 2.0;
			y = -390.0;
			blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA };
			color = { 1.0, 1.0, 1.0, 0.35 };
			
			deck = rm:rsrc ( gui.GfxQuad )
			{
				sprite = "wheel_shadow.png";
				alignX = 0, alignY = 0;
				scaleX = 1.45, scaleY = 0.25;
			}
		},		
		
		rm:rsrc ( gui.Widget, "video" )
		{
		},
		
		rm:rsrc ( gui.Widget )
		{	
			deck = rm:rsrc ( gui.GfxQuad )
			{
				sprite = "video_frame.png";
				alignX = -1, alignY = 1;
				scaleX = -1, scaleY = 1;
			}
		},
		
		rm:rsrc ( gui.TextBox, "text" )
		{
			x = -312.0 / 2.0;
			y = -390.0 / 2.0;
			font = "art/fonts/arial_round.fnt",
			color = { 0.0, 0.0, 0.0, 0.5 },
			fontSize = 40,
			rect = {-300, -300, 300, 300,},
		},		
    },
	
	rm:rsrc ( gui.Button, "/btnInfo" )
	{
		id = "GameView.Info";
		x = - 0.5 * MODEL_SCREEN_W, y = 0.5 * MODEL_SCREEN_H;

		deck = rm:rsrc ( gui.GfxQuadListDeck )
		{
			[ gui.Button.REGULAR ] =
			{
				{ sprite = "btn_menu.png";			x = 37, y = -37; alignX =  0, alignY = 0; scaleX = 1.0, scaleY = 1.0; },
				{ sprite = "btn_menu_txt_i.png";    x = 36, y = -34; alignX =  0, alignY = 0; scaleX = 1.0, scaleY = 1.0; },
			},

			[ gui.Button.PRESSED ] =
			{
				{ sprite = "btn_menu.png";			x = 37, y = -37; alignX =  0, alignY = 0; scaleX = 0.95, scaleY = 0.95; },
				{ sprite = "btn_menu_txt_i.png";	x = 36, y = -34; alignX =  0, alignY = 0; scaleX = 0.95, scaleY = 0.95; },
			},
		};
	},
		
	rm:rsrc ( gui.Button, "/btnExit" )
	{
		id = "GameView.Exit";
		x = 0.5 * MODEL_SCREEN_W, y = 0.5 * MODEL_SCREEN_H;
		
		deck = rm:rsrc ( gui.GfxQuadListDeck )
		{
			[ gui.Button.REGULAR ] =
			{
				{ sprite = "btn_menu.png";			x =   -37, y = -37; alignX = 0, alignY = 0; scaleX = 1.0, scaleY = 1.0; },
				{ sprite = "btn_menu_txt_x.png";	x = -37.5, y = -34; alignX = 0, alignY = 0; scaleX = 1.0, scaleY = 1.0; },
			},
			
			[ gui.Button.PRESSED ] =
			{
				{ sprite = "btn_menu.png"; 			x =   -37, y = -37; alignX = 0, alignY = 0; scaleX = 0.95, scaleY = 0.95; },
				{ sprite = "btn_menu_txt_x.png";	x = -37.5, y = -34; alignX = 0, alignY = 0; scaleX = 0.95, scaleY = 0.95; },
			},
		};
	},	
	
    rm:rsrc ( gui.Widget )
    {
		x = - 0.5 * MODEL_SCREEN_W - 0.475 * 342;
		y = - 0.5 * MODEL_SCREEN_H - 0.475 * 342;
		blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA };
		color = { 1.0, 1.0, 1.0, 0.35 };
		
		deck = rm:rsrc ( gui.GfxQuad )
		{
			sprite = "wheel_shadow.png";
			scaleX = 4.0, scaleY = 4.0;
		};	
	},
	
    rm:rsrc ( gui.Widget )
    {
		x = 0.5 * MODEL_SCREEN_W + 0.475 * 342;
		y = - 0.5 * MODEL_SCREEN_H - 0.475 * 342;
		blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA };
		color = { 1.0, 1.0, 1.0, 0.35 };
		
		deck = rm:rsrc ( gui.GfxQuad )
		{
			sprite = "wheel_shadow.png";
			scaleX = 4.0, scaleY = 4.0;
		};	
	},	
	
    rm:rsrc ( gui.Widget )
    {
		x = 0, y = -167.0;
		
		rm:rsrc ( gui.Widget )
		{
			x = 0, y = -25.0;
			
			deck = rm:rsrc ( gui.GfxQuad )
			{
				sprite = "wheel_shadow.png";
				scaleX = 4.0;
				scaleY = 4.0; -- * ( 0.5 * MODEL_SCREEN_H - 167 ) / ( 480 - 167 );
			};		
		},		

		rm:rsrc ( gui.Widget )
		{
			x = 0, y = -0.5;
			
			deck = rm:rsrc ( gui.GfxQuad )
			{
				sprite = "wheel_bg.png";
				scaleX = 2.0, scaleY = 2.0;
			};			
		},		
		
		rm:rsrc ( gui.Widget )
		{		
			deck = rm:rsrc ( gui.GfxQuad )
			{
				sprite = "tango_logo.png";
				scaleX = 1.0, scaleY = 1.0;
			};			
		},
	},
}

