LocalPlayer = core.class ( Object )

function LocalPlayer:ctor ( model, gameView, index )
    self.model = model
    self.gameView = gameView
    self.index = index
    self.isActive = false

	app.queue:subscribe ( self, self.onSceneHide, gui.E_SCENE.HIDE )
    app.queue:subscribe ( self, self.onAction, gui.E_ACTION )
    app.queue:subscribe ( self, self.onModelStateChanged, Model.E_STATE_CHANGED )
	app.queue:subscribe ( self, self.onSpinStop, WheelView.E_SPIN.STOP )
    -- app.queue:subscribe ( self, self.onHandCompleted, Model.E_HAND_COMPLETED )
    gameView.actionShowed:connect ( self, self.onActionShowed )
end

function LocalPlayer:dtor ()
    -- gameView.handClicked:disconnect ( self, self.onHandClicked )
    -- app.queue:unsubscribe ( self, self.onHandCompleted, Model.E_HAND_COMPLETED )
	app.queue:unsubscribe ( self, self.onSceneHide, gui.E_SCENE.HIDE )
    app.queue:unsubscribe ( self, self.onModelStateChanged, Model.E_STATE_CHANGED )
    app.queue:unsubscribe ( self, self.onAction, gui.E_ACTION )
	app.queue:unsubscribe ( self, self.onAction, WheelView.E_SPIN.STOP )
end

function LocalPlayer:activate ()
    self.isActive = true
end

function LocalPlayer:deactivate ()
    self.isActive = false
end

function LocalPlayer:setActive ( isActive )
	if isActive then
		self:activate ()
	else
		if self.model.isMultiplayer then
			self:deactivate ()
		end
	end
end

function LocalPlayer:onSceneHide ( sender, event, args )
	if sender == self.currDlg then
		self.currDlg = nil
	end
end

function LocalPlayer:onModelStateChanged ( sender, event, args )
    local model, gv = self.model, self.gameView
    local prevState, nextState = args.prevState, args.nextState


    if nextState == model.STATE_ROUND_BEG then
		self._result = nil
		self.isActionShowed = false
		
		gv:showRoundStart ( self.isActive )
		-- gv:showRoundStart ( true )
		model:startSpinning ()
    end

	if nextState == model.STATE_SPINNING then
		gv:showSpinning ( self.isActive )
		-- gv:showSpinning ( true )
	end
	
	if nextState == model.STATE_ACTION then
		gv:showAction ( model.isMultiplayer, self.isActive, model:getAction () )
	end
	
	if nextState == model.STATE_RESULT then
		gv:enableResultControls ( false )
		local function onActionHidden ()
			if self.isActive then
				-- Timer.new ( 10.0,
					-- function ()
						-- model:endRound ()
					-- end
				-- ):start ( 1 )	
				model:endRound ()
			else
				local function onResultShowed ()		
					model:endRound ()
				end
				
				gv:showResult ( model:getResult (), onResultShowed )
			end		
		end
		
		gv:hideAction ( onActionHidden )
	end
end

function LocalPlayer:onAction ( sender, event, args )
    -- if not self.isActive then
        -- return
    -- end

    local model = self.model
    local gv = self.gameView

    print ( "onAction:", args.id )
	
	-- if args.id == "GameView.Wheel" then
		-- model:chooseAction ( args.action )
	-- end
	
	if args.id == "GameView.Bad" then
		av:playSound ( "art/sounds/click.ogg" )
		
		model:setResult ( Parties.PLAYER_2, false )
	end
	
	if args.id == "GameView.Good" then
		av:playSound ( "art/sounds/click.ogg" )
		
		model:setResult ( Parties.PLAYER_2, true )
	end	
	
	if args.id == "GameView.Exit" then
		if not self.currDlg then
			av:playSound ( "art/sounds/click.ogg" )
			
			self.currDlg = DlgExit.new ()
			self.currDlg:show ()
		end
	end

	if args.id == "GameView.Info" then
		if not self.currDlg then
			av:playSound ( "art/sounds/click.ogg" )
			
			self.currDlg = DlgHelp.new ()
			self.currDlg:show ()
		end
	end
	
	if args.id == "DlgExit.Done" then
		if self.currDlg then
			av:playSound ( "art/sounds/click.ogg" )
			
			self.currDlg:hide ()
			-- self.currDlg = nil
		end
	end

	if args.id == "DlgHelp.Done" then
		if self.currDlg then
			av:playSound ( "art/sounds/click.ogg" )
			
			self.currDlg:hide ()
			-- self.currDlg = nil
		end
	end
				
end

function LocalPlayer:spin ( speed, rotation )
	self.gameView:showSpin ( speed, rotation )
end

function LocalPlayer:showRate ()
	self.gameView:showRate ()
end

function LocalPlayer:onSpinStop ( sender, event, args )
	self.model:chooseAction ( args.action )
end

function LocalPlayer:setResult ( result )
	if self.isActionShowed then
		self:showResult ( result )
	else
		self._result = result
	end
end

function LocalPlayer:showResult ( result )
	self.model:setResult ( Parties.PLAYER_1, result )
end

function LocalPlayer:onActionShowed ()
    local model, gv = self.model, self.gameView
	
	self.isActionShowed = true

	if model.isMultiplayer then
		gv:enableResultControls ( self.isActive )
		
		if self._result ~= nil then
			self:showResult ( self._result )
		end
	else
		model:endRound ()
	end
		
end
