DlgCamera = core.class ( gui.Scene )

local TRANSITION_DURATION = 0.5


local RSRC_VIEW = rm:rsrc ( gui.Widget )
{
    x = 0, y = 0;
    -- rotation = 90;

    rm:rsrc ( gui.Widget, "/wdgOverlay" )
    {
        color = { 0, 0, 0, 0 };
        deck = rm:rsrc ( gui.GfxQuad )
        {
            sprite = "bg_white.png";
            scaleX = 3.0, scaleY = 3.0;
        };
    },
	
    rm:rsrc ( gui.Widget, "/wdgBG" )
    {
        deck = rm:rsrc ( gui.GfxQuad )
        {
            sprite = "popup_bg.png";
            scaleX = 2.0, scaleY = 2.0;
        };
		
        rm:rsrc ( gui.TextBox, "/txtShadow" )
        {
            x = 4, y = 70;
            color = { 0.0, 0.0, 0.0, 0.5 };
            text = "TURN ON\nYOUR\nCAMERA?";
            font = "art/fonts/arial_round.fnt",
            fontSize = 63;
            rect = { -300, -150, 300, 150 };
        },
		
        rm:rsrc ( gui.TextBox, "/txtTitle" )
        {
            x = 0, y = 75;
            color = { 1.0, 1.0, 1.0, 1.0 };
            text = "TURN ON\nYOUR\nCAMERA?";
            font = "art/fonts/arial_round.fnt",
            fontSize = 63;
            rect = { -300, -150, 300, 150 };
        },

        rm:rsrc ( DialogButton, "/btnDone" )
        {
            x = 107, y = -109;
            id = "DlgCamera.No";
			sprite = "smile_bad.png";
			text = "NO";
        },

        rm:rsrc ( DialogButton, "/btnExit" )
        {
            x = -107, y = -109;
            id = "DlgCamera.Yes";
			sprite = "smile_good.png";
            text = "YES",
        },
	
		rm:rsrc ( gui.Widget, "/wdgGlow" )
		{
			color = { 1.0, 1.0, 1.0, 1.0 };
			-- blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA };
			deck = rm:rsrc ( gui.GfxQuad )
			{
				sprite = "popup_glow.png";
				scaleX = 2.0, scaleY = 2.0;
			};
		},		
    },	
}

function DlgCamera:ctor (  )
    local root = RSRC_VIEW:create ()
    gui.Scene.ctor ( self, root )

    self._inputListeners =
    {
        self,
        root.btnExit, root.btnDone,
    }
	
	local curve = MOAIAnimCurve.new ()
    curve:reserveKeys ( 3 )
    curve:setKey ( 1, 0.0, 0.625 )
    curve:setKey ( 2, 0.5, 1.000 )
	curve:setKey ( 3, 1.0, 0.625 )
    curve:setWrapMode ( MOAIAnimCurve.WRAP )
	
	local anim = MOAIAnim.new ()
	anim:reserveLinks ( 1 )
	anim:setLink ( 1, curve, root.wdgGlow.prop, MOAIProp2D.ATTR_A_COL )
	anim:setMode ( MOAITimer.CONTINUE )
	
	self.glowAnim = anim
end

function DlgCamera:showGlow ( show )
	if show then
        self.glowAnim:start ()
    else
        self.glowAnim:stop ()
    end
end

function DlgCamera:onShowTransition ()
    local root = self.root
	
	self:showGlow ( true )
	
    local dx, dy = 0, 0.5 * MODEL_SCREEN_H + 220
    root.wdgBG.transform:moveLoc ( dx, dy )
    root.wdgBG.transform:moveLoc ( dx, -dy, TRANSITION_DURATION )
        :setListener ( MOAIAction.EVENT_STOP, 
            function ()
                self:onShow ()
            end
        )

    root.wdgOverlay.prop:seekColor ( 0, 0, 0, 0.7, TRANSITION_DURATION )
end

function DlgCamera:onHideTransition ()
    local root = self.root
	
	self:showGlow ( false )
    
	local dx, dy = 0, 0.5 * MODEL_SCREEN_H + 220
    root.wdgBG.transform:moveLoc ( dx, dy, TRANSITION_DURATION )
        :setListener ( MOAIAction.EVENT_STOP, 
            function ()
                self:onHide ()
            end
        )

    root.wdgOverlay.prop:seekColor ( 0, 0, 0, 0.0, TRANSITION_DURATION )
end

function DlgCamera:onTouchBegan ( sender, event, args )
    local touches = args.touches
    if touches.n > 1 then
        return
    end
end