DlgHelp = core.class ( gui.Scene )

local TRANSITION_DURATION = 0.5

local RSRC_POPUP_VIEW = rm:rsrc ( gui.Widget )
{
    x = 0, y = 0;

    rm:rsrc ( gui.Widget, "/wdgOverlay" )
    {
        color = { 0, 0, 0, 0 };
        deck = rm:rsrc ( gui.GfxQuad )
        {
            sprite = "bg_white.png";
            scaleX = 3.0, scaleY = 3.0;
        };
    },

    rm:rsrc ( gui.Widget, "/wdgBG" )
    {
        rm:rsrc ( gui.TextBox, "/txtInfo" )
        {
            x = 0, y = 0;
            font = "art/fonts/arial_round.fnt",
            fontSize = 50;
            -- textAlignX = MOAITextBox.LEFT_JUSTIFY;
            rect = { - 0.5 * MODEL_SCREEN_W + 20, - 0.5 * MODEL_SCREEN_H + 20, 
					   0.5 * MODEL_SCREEN_W - 20,   0.5 * MODEL_SCREEN_H - 20 };
        },
		
		rm:rsrc ( gui.TextBox, "/txtClose" )
        {
            x = 0, y = 0;
            font = "art/fonts/arial_round.fnt",
            fontSize = 30;
            -- textAlignX = MOAITextBox.LEFT_JUSTIFY;
            rect = { - 0.5 * MODEL_SCREEN_W + 20, - 0.5 * MODEL_SCREEN_H , 
					   0.5 * MODEL_SCREEN_W - 20, - 0.5 * MODEL_SCREEN_H + 80};
        },
    },
	
}

function DlgHelp:ctor ( startup )
    local root = RSRC_POPUP_VIEW:create ()
    gui.Scene.ctor ( self, root )

    root.txtInfo.prop:setString
-- <c:FFD700D7>
[[
SPIN THE WHEEL
TO CHOOSE A DARE 
FOR YOUR FRIEND!

THEY PERFORM,
YOU RATE,
THEN SWITCH TURNS!
]]
-- </>

	root.txtClose.prop:setVisible ( false )

	local text = startup and "TAP TO START" or "TAP TO CLOSE"
	root.txtClose.prop:setString ( text )
	
	local curve = MOAIAnimCurve.new ()
    curve:reserveKeys ( 3 )
    curve:setKey ( 1, 0.0, 0.5 )
    curve:setKey ( 2, 0.5, 1.0 )
	curve:setKey ( 3, 1.0, 0.5 )	
    curve:setWrapMode ( MOAIAnimCurve.WRAP )
	
	local anim = MOAIAnim.new ()
	anim:reserveLinks ( 1 )
	anim:setLink ( 1, curve, root.txtClose.prop, MOAIProp2D.ATTR_A_COL )
	anim:setMode ( MOAITimer.CONTINUE )
	
	self.txtCloseAnim = anim
end

function DlgHelp:onShowTransition ()
    local root = self.root
	
    local dx, dy = 0, 0.5 * MODEL_SCREEN_H + 220
    root.wdgBG.transform:moveLoc ( dx, dy )
    root.wdgBG.transform:moveLoc ( dx, -dy, TRANSITION_DURATION )
        :setListener ( MOAIAction.EVENT_STOP, 
            function ()
                self:onShow ()
				
				root.txtClose.prop:setVisible ( true )
				self.txtCloseAnim:start ()				
            end
        )

    root.wdgOverlay.prop:seekColor ( 0, 0, 0, 0.85, TRANSITION_DURATION )
end

function DlgHelp:onHideTransition ()
    local root = self.root
    
	root.txtClose.prop:setVisible ( false )
	self.txtCloseAnim:stop ()
	
	local dx, dy = 0, 0.5 * MODEL_SCREEN_H + 220
    root.wdgBG.transform:moveLoc ( dx, dy, TRANSITION_DURATION )
        :setListener ( MOAIAction.EVENT_STOP, 
            function ()
                self:onHide ()
            end
        )
	
    root.wdgOverlay.prop:seekColor ( 0, 0, 0, 0.0, TRANSITION_DURATION )
end

function DlgHelp:onTouchBegan ( sender, event, args )
    local touches = args.touches
    if touches.n > 1 then
        return
    end

    app.queue:postEvent ( self, gui.E_ACTION, { id = "DlgHelp.Done" } )
end
