DlgPopup = core.class ( gui.Scene )

local TRANSITION_DURATION = 0.5

local RSRC_POPUP_VIEW = rm:rsrc ( gui.Widget )
{
    x = 0, y = 0;
    rotation = 90;

    rm:rsrc ( gui.Widget, "/wdgOverlay" )
    {
        color = { 0, 0, 0, 0 };
        deck = rm:rsrc ( gui.GfxQuad )
        {
            sprite = "white_16x16.png";
            scaleX = 100.0, scaleY = 100.0;
        };
    },

    rm:rsrc ( gui.Widget, "/wdgBG" )
    {
        rm:rsrc ( gui.Widget, "/wdgTitle" )
        {
            rm:rsrc ( gui.TextBox, "/txtTitle" )
            {
                x = 0, y = 50;
                color = { 0.9296875, 0.8515625, 0.38671875 };
                font = "art/fonts/palatino.fnt",
                fontSize = 70;
                rect = { -300, -85, 300, 85 };
            },
        },

        rm:rsrc ( gui.Widget, "/wdgMessage" )
        {
            rm:rsrc ( gui.TextBox, "/txtMessage" )
            {
                x = 0, y = -50;
                color = { 0.9296875, 0.8515625, 0.38671875 };
                font = "art/fonts/palatino.fnt",
                fontSize = 50;
                rect = { -300, -85, 300, 85 };
            },
        },
    },
}

function DlgPopup:ctor ( title, text )
    local root = RSRC_POPUP_VIEW:create ()
    gui.Scene.ctor ( self, root )
    root.txtTitle.prop:setString ( title )
    root.txtMessage.prop:setString ( text )
end

function DlgPopup:onShowTransition ()
    local root = self.root
    local dx, dy = 0, 600

    root.wdgTitle.transform:moveLoc ( dx, dy )
    root.wdgTitle.transform:moveLoc ( dx, -dy, TRANSITION_DURATION )
        :setListener ( MOAIAction.EVENT_STOP, 
            function ()
                self:onShow ()
            end
        )

    root.wdgMessage.transform:moveLoc ( dx, -dy )
    root.wdgMessage.transform:moveLoc ( dx,  dy, TRANSITION_DURATION )

    root.wdgOverlay.prop:seekColor ( 0, 0, 0, 0.7, TRANSITION_DURATION )
end

function DlgPopup:onHideTransition ()
    local root = self.root
    local dx, dy = 0, 600

    root.wdgTitle.transform:moveLoc ( dx, dy, TRANSITION_DURATION )
        :setListener ( MOAIAction.EVENT_STOP, 
            function ()
                self:onHide ()
            end
        )

    root.wdgMessage.transform:moveLoc ( dx, -dy, TRANSITION_DURATION )
    root.wdgOverlay.prop:seekColor ( 0, 0, 0, 0.0, TRANSITION_DURATION )
end
