GameView = core.class ( gui.Scene )
{
	E_VIEW = Event.declare "View"
		:types
		{
			PERFORM = 1,
		};
}

local RSRC_WHEEL = rm:rsrc ( WheelView )
{
	id = "GameView.Wheel";
    x = 0, y = -167;
	
	innerRadius = 43;
	outerRadius = 271.5;

	rm:rsrc ( gui.Widget, "/regular" )
	{
		piv = { 0.0, -1.0 };
		
		deck = rm:rsrc ( gui.GfxQuad )
		{
			sprite = "wheel_regular.png";
			scaleX = 2.0, scaleY = 2.0;			
		};
		
		rm:rsrc ( gui.Widget, "/smiles" )
		{
			rm:rsrc ( gui.Widget, "/song" )
			{
				blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA };
				deck = rm:rsrc ( gui.GfxQuad )
				{
					sprite = "smile_1.png";
					scaleX = 1.0, scaleY = 1.0;	
				};
			},
			
			rm:rsrc ( gui.Widget, "/accent" )
			{
				blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA };
				deck = rm:rsrc ( gui.GfxQuad )
				{
					sprite = "smile_2.png";
					scaleX = 1.0, scaleY = 1.0;
				};
			},
			
			rm:rsrc ( gui.Widget, "/love" )
			{
				blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA };
				deck = rm:rsrc ( gui.GfxQuad )
				{
					sprite = "smile_3.png";
					scaleX = 1.0, scaleY = 1.0;	
				};
			},
			
			rm:rsrc ( gui.Widget, "/impress" )
			{
				blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA };
				deck = rm:rsrc ( gui.GfxQuad )
				{
					sprite = "smile_4.png";
					scaleX = 1.0, scaleY = 1.0;
				};
			},
			
			rm:rsrc ( gui.Widget, "/funny" )
			{
				blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA };
				deck = rm:rsrc ( gui.GfxQuad )
				{
					sprite = "smile_5.png";
					scaleX = 1.0, scaleY = 1.0;	
				};
			},	

			rm:rsrc ( gui.Widget, "/nose" )
			{
				color = { 1.0, 1.0, 1.0, 0.7 };
				blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA };
				deck = rm:rsrc ( gui.GfxQuad )
				{
					sprite = "smile_6.png";
					scaleX = 1.0, scaleY = 1.0;	
				};
			},
			
			rm:rsrc ( gui.Widget, "/cat" )
			{
				blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA };
				deck = rm:rsrc ( gui.GfxQuad )
				{
					sprite = "smile_7.png";
					scaleX = 1.0, scaleY = 1.0;	
				};
			},

			rm:rsrc ( gui.Widget, "/secret" )
			{
				blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA };
				deck = rm:rsrc ( gui.GfxQuad )
				{
					sprite = "smile_8.png";
					scaleX = 1.0, scaleY = 1.0;	
				};
			},				
		},	
	},
	
	rm:rsrc ( gui.Widget, "/spinning" )
	{
		-- piv = { 0.5, -1.5 };
		piv = { 0.5, -1.25 };
		
		blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA };
		
		deck = rm:rsrc ( gui.GfxQuad )
		{
			sprite = "wheel_spinning.png";
			scaleX = 2.0, scaleY = 2.0;			
		};
	},
}

local RSRC_WHEEL_FOCUS = rm:rsrc ( gui.Widget )
{
	x = 0, y = -162;
    
	-- blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_DST_ALPHA };
	
	deck = rm:rsrc ( gui.GfxQuad )
    {
        sprite = "wheel_focus.png";
		x = 0, y = -8;
		alignX = 0, alignY = -1;
		scaleX = 2.0, scaleY = 2.0;
	};
}

local RSRC_INDICATOR = rm:rsrc ( gui.Widget )
{
	x = 5.5, y = 107;

	deck = rm:rsrc ( gui.GfxQuad )
    {
        sprite = "indicator.png",
		scaleX = 1.0, scaleY = 1.0;
    };
}

local RSRC_ARROW = rm:rsrc ( gui.Widget )
{
	x = 12, y = -167;
	
	piv = { -12, 0 };
	
	blend = { src = MOAIProp2D.GL_SRC_ALPHA, dst = MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA };	
	
	deck = rm:rsrc ( gui.GfxQuad )
    {
        sprite = "arrow.png",
		scaleX = 2.0, scaleY = 2.0;
    };
} 

local ACTION_TXT =
{
	[ true ] =
	{
		"SING\nA SONG",
		"TALK IN\nA FOREIGN ACCENT",
		"SHOW YOU\nSOME LOVE",
		"DO\nAN IMPRESSION",
		"MAKE\nA FUNNY FACE",	
		"LICK\nTHEIR NOSE",
		"BARK\nLIKE A DOG",
		"TELL YOU\nA SECRET",	
	},
	
	[ false ] =
	{
		"SING\nA SONG",
		"TALK IN\nA FOREIGN ACCENT",
		"SHOW ME\nSOME LOVE",
		"DO\nAN IMPRESSION",
		"MAKE\nA FUNNY FACE",	
		"LICK\nYOUR NOSE",
		"BARK\nLIKE A DOG",
		"TELL ME\nA SECRET",	
	},
}

local RESULT_TXT =
{
	[ true ] =
	{
		{ text = "GOOD!", size = 80, },
		{ text = "EXCELLENT!", size = 80, },
		{ text = "GOOD JOB!", size = 80, },
		{ text = "WELL DONE!", size = 80, },
	},
	
	[ false ] =
	{
		{ text = "BAD!", size = 80, },
		-- { text = "TRY BETTER!", size = 80, },
		{ text = "TRY HARDER!", size = 80, },
	},
}

function GameView:createShader ( name )
	local file

	file = assert ( io.open ( string.format ( "src/view/shaders/%s.vsh", name ) ) )
	local vsh = file:read ( "*all" )
	file:close ()

	file = assert ( io.open ( string.format ( "src/view/shaders/%s.fsh", name ) ) )
	local fsh = file:read ( "*all" )
	file:close ()

	local shader = MOAIShader.new ()

	shader:reserveUniforms ( 2 )
	shader:declareUniformSampler ( 1, "sampler0", 1 )
	shader:declareUniformSampler ( 2, "sampler1", 2 )

	shader:setVertexAttribute ( 1, "position" )
	shader:setVertexAttribute ( 2, "uv" )
	shader:setVertexAttribute ( 3, "color" )
	shader:load ( vsh, fsh )

	return shader
end

function GameView:wait ( action )
	while action:isBusy () do coroutine:yield () end
end
	
function GameView:ctor ( model )
    local root = rm.RSRC_GAME_VIEW:create ()
    gui.Scene.ctor ( self, root )
	
    self._inputListeners =
    {
        self,

        root.btnExit,
		root.btnInfo,
    }

    self.model = model

	self.resultControls = {}
	
	
	self.hasVideoPreview  = false
	self.hasVideoPlayback = false
	
	-- if MOAIVideoTexture and vsc and vsc:isSendingSupported() then
		local RSRC_VIDEO_PREVIEW = rm:rsrc ( gui.Widget, "/preview" )
		{
			deck = rm:rsrc ( gui.GfxQuad )
			{
				rect = { 0, 0, 312, -390 },
				uvRect = { 0, 0, 1, 1 },
				texture = rm:rsrc ( gui.MultiTexture )
				{
					"art/textures/video_mask.png",
					"art/textures/video_placeholder.png",
					-- rm:rsrc ( gui.VideoTexture )
					-- {
						-- type = MOAIVideoTexture.PREVIEW,
					-- },
				}
			},
			
			shader = self:createShader ( "PreviewShader" ),
		}
		
		RSRC_VIDEO_PREVIEW:create ()
			:attach ( root.previewBackground.video )
	-- end
	
	-- if MOAIVideoTexture then
		local RSRC_VIDEO_PLAYBACK = rm:rsrc ( gui.Widget, "/playback" )
		{
			deck = rm:rsrc ( gui.GfxQuad )
			{
				rect = { -312, 0, 0, -390 },			
				uvRect = { 0, 0, 1, 1 },	
				texture = rm:rsrc ( gui.MultiTexture )
				{
					"art/textures/video_mask.png",
					"art/textures/video_placeholder.png",
					-- "art/textures/placeholder.png",
					-- rm:rsrc ( gui.VideoTexture )
					-- {
						-- type = MOAIVideoTexture.PLAYBACK,
					-- },
				}				
			},

			shader = self:createShader ( "PlaybackShader" ),
		}
		
		RSRC_VIDEO_PLAYBACK:create ()
			:attach ( root.playbackBackground.video )	
	-- end
					
	self.wheelView = RSRC_WHEEL:create ()
		:attach ( root )
		
	self.wheelView.started:connect ( self, self.onWheelStarted )			
	self.wheelView.stopped:connect ( self, self.onWheelStopped )
	self.wheelView.rejected:connect ( self, self.onWheelRejected )
	
	table.insert ( self._inputListeners, self.wheelView )	

	self.wheelFocus = RSRC_WHEEL_FOCUS:create ()
		:attach ( root )
		
	local curve = MOAIAnimCurve.new ()
    curve:reserveKeys ( 3 )
    curve:setKey ( 1, 0.0, 0.625 )
    curve:setKey ( 2, 0.5, 1.000 )
	curve:setKey ( 3, 1.0, 0.625 )
    curve:setWrapMode ( MOAIAnimCurve.WRAP )
	
	local anim = MOAIAnim.new ()
	anim:reserveLinks ( 1 )
	anim:setLink ( 1, curve, self.wheelFocus.prop, MOAIProp2D.ATTR_A_COL )
	anim:setMode ( MOAITimer.CONTINUE )

	self.focusAnim = anim
		
	self:setFocusVisible ( false )

	self.arrowView = RSRC_ARROW:create ()
		:attach ( self.root )
	self.arrowView.prop:setVisible ( false )
	
	self.indicator = RSRC_INDICATOR:create ()
		:attach ( root )

	self.actionShowed = core.signal ()
	
	self.isPopupHidden = true
	self.isPopupVisible = false	
	
	self:enableResultControls ( false )
	
	app.queue:subscribe ( self, self.onResume, E_SYSTEM.RESUME )
	
    -- self.inputLock = 0

    -- -- connect slots
    -- app.queue:subscribe ( self, self.onModelStateChanged, model.E_STATE_CHANGED, model )
end

function GameView:onResume ()
	self:updateVideoPreview  ( self.hasVideoPreview,  true )
	self:updateVideoPlayback ( self.hasVideoPlayback, true )
end

function GameView:onWheelStarted ()
	self:showWaitingFriend ( false )
	self:showSpinPopup ( false )
end

function GameView:onWheelStopped ( action )
	local rot = self.wheelView.transform:getRot ()
	local sectorSize = 360.0 / self.wheelView.SECTOR_COUNT
	rot = rot - sectorSize * ( action - 1 )	
	
	self.wheelFocus.transform:setRot ( rot )
	self:setFocusVisible ( true )
	
	av:playSound ( "art/sounds/stop.ogg" )
	
	-- local c = self.wheelView.SECTOR_COLOR [ action ]
	-- self.playerIndicator.transform:setColor ( c.r / 255, c.g / 255, c.b / 255 )
end

function GameView:onWheelRejected ()
	self:showArrow ()
end

function GameView:setFocusVisible ( isVisible )	
	self.wheelFocus.prop:setVisible ( isVisible )
	
	if isVisible then
        self.focusAnim:start ()
    else
        self.focusAnim:stop ()
    end
end

function GameView:showRoundStart ( isActive )
	self.wheelView:setActive ( isActive )
	
	if isActive then
		self:showSpinPopup ( true )
	end
	
	if isActive then
		self:showArrow ()
	end
	
	self.isPerformShowed = false
	self.isRateShowed = false
end

function GameView:showArrow ()
	if self.isArrowVisible then
		return 
	end

	self.isArrowVisible = true
	
	local view = self.arrowView
	view.prop:setVisible ( true )
	
	local rotCurve = MOAIAnimCurve.new ()
    rotCurve:reserveKeys ( 2 )
    rotCurve:setKey ( 1, 0.0, 0.0 )
    rotCurve:setKey ( 2, 2.0, -540.0 )
	
	local colCurve = MOAIAnimCurve.new ()
    colCurve:reserveKeys ( 2 )
    colCurve:setKey ( 1, 0.0, 0.5	)
    colCurve:setKey ( 2, 2.0, 0.0 )	
	
	local anim = MOAIAnim.new ()
	anim:reserveLinks ( 2 )
	anim:setLink ( 1, rotCurve, view.prop, MOAIProp2D.ATTR_Z_ROT )
	anim:setLink ( 2, colCurve, view.prop, MOAIProp2D.ATTR_A_COL )

	function onStop ()
		view.prop:setVisible ( false )	
		self.isArrowVisible = false
	end
	
	anim:setListener ( MOAIAction.EVENT_STOP, onStop )
	anim:start()
end

function GameView:showSpinning ( isActive )
	self.wheelView:setEnabled ( isActive )
end

function GameView:_setActionVisible ( isVisible )
	if self.actionView then	
		-- self.actionView.background.prop:setVisible ( isVisible )
		self.actionView.text.prop:setVisible ( isVisible )
	end
end

function GameView:showChildren ( widget, show )
	for w in widget:iterChildren () do
		self:setVisible ( w, show )
	end		
end

function GameView:setVisible ( widget, visible )
	if widget.prop then
		widget.prop:setVisible ( visible )
	end
	
	self:showChildren ( widget, visible )
end

function GameView:showAction ( isMultiplayer, isActive, action )
	if isMultiplayer then
		if isActive then
			self:showActionRate ( true, action )
		else
			self:showActionPerform ( action )
		end
	else
		self:showActionRate ( false, action )
	end
end

function GameView:hideAction ( callback )	
	local view = self.actionView
	
	if not view then
		return
	end
	
	local dx, dy = 0, - MODEL_SCREEN_H - 397.0 / 2.0
	
	self:showChildren ( view, false )
	view.background.prop:setVisible ( true )
	
	view.transform:moveLoc ( dx, dy, 0.5 )
		:setListener ( MOAIAction.EVENT_STOP, callback )
end

function GameView:createBounceAnim ( widgets, duration, callback )
	if not widgets then
		return
	end

	local curve = MOAIAnimCurve.new ()
	curve:reserveKeys ( 5 )
	curve:setKey ( 1, 0.00, 0.1 )
	curve:setKey ( 2, 0.25, 1.1 )
	curve:setKey ( 3, 0.50, 0.9 )
	curve:setKey ( 4, 0.75, 1.0 )	
	curve:setKey ( 5, duration, 1.0 )
	
	local anim = MOAIAnim.new ()
	anim:reserveLinks ( 2 * #widgets )	
	for i, w in ipairs ( widgets ) do
		if w and w.prop ~= nil then
			anim:setLink ( 2 * i - 1, curve, w.prop, MOAITransform.ATTR_X_SCL )
			anim:setLink ( 2 * i, curve, w.prop, MOAITransform.ATTR_Y_SCL )
		end
	end
	
	if callback then
		anim:setListener ( MOAIAction.EVENT_STOP, callback )
	end

	return anim
end


function GameView:showActionPerform ( action )
	local gv = self
	
	-- self.wheelView:setEnabled ( false )	
	
	local dx, dy = 0, - MODEL_SCREEN_H - 397.0 / 2.0
	
	if not self.actionViewPerform then
		self.actionViewPerform = rm.RSRC_ACTION_PERFORM:create ()
			:attach ( self.root )
			
		self.actionViewPerform.transform:moveLoc ( dx, dy )
	end
	
	self.actionView = self.actionViewPerform
	
	local view = self.actionViewPerform
	local actionCount = #ACTION_TXT [ false ]
	action = ( action - 1 ) % actionCount + 1
	
	local smiles = view.smile:getChildren ()	
	for _, smile in ipairs ( smiles ) do
		smile:detach ()
	end
	
	local RSRC_SMILE = rm:rsrc ( gui.Widget )
	{
		-- color = { 0, 0, 0, 0.6 };
		deck = rm:rsrc ( gui.GfxQuad )
		{
			sprite = string.format ( "smile_%d.png", action ); 
			scaleX = 1.8, scaleY = 1.8;
		};
	}
	
	local smile = RSRC_SMILE:create ()
		:attach ( view.smile )
	
	self:setVisible ( view, false )
	
	-- local c = self.wheelView.SECTOR_COLOR [ action ]
	-- view.background.prop:setColor ( c.r / 255, c.g / 255, c.b / 255, 0.8 )	
	view.background.prop:setVisible ( true )
	
	local function showContent ()
		local text = ACTION_TXT [ false ] [ action ]
		view.text.prop:setVisible ( true )
		view.text.prop:setString ( text )
		
		self:setVisible ( view.smile, true )
		
		local function showTimer ()
			self:setVisible ( view.smile, false )
			view.timer.prop:setVisible ( true )
			
			local function scaleTimer ()
				local sizeCurve = MOAIAnimCurve.new ()
				sizeCurve:reserveKeys ( 2 )
				sizeCurve:setKey ( 1, 0.0, 0.01 )
				sizeCurve:setKey ( 2, 1.5, 2.00 )
				
				local colCurve = MOAIAnimCurve.new ()
				colCurve:reserveKeys ( 2 )
				colCurve:setKey ( 1, 0.0, 1.0 )
				colCurve:setKey ( 2, 1.5, 0.0 )	
				
				local anim = MOAIAnim.new ()
				anim:reserveLinks ( 3 )
				anim:setLink ( 1, sizeCurve, view.timer.prop, MOAITransform.ATTR_X_SCL )
				anim:setLink ( 2, sizeCurve, view.timer.prop, MOAITransform.ATTR_Y_SCL )
				anim:setLink ( 3, colCurve,  view.timer.prop, MOAIProp2D.ATTR_A_COL )

				return anim
			end
			
			local function threadFunc ()
				local anim = scaleTimer ()
				for i = 3, 1, -1 do
					av:playSound ( "art/sounds/tick.ogg" )
					
					view.timer.prop:setIndex ( i )
					gv:wait ( anim:start () )
				end
				view.timer.prop:setVisible ( false )
				
				av:playSound ( "art/sounds/tick_last.ogg" )
				
				view.perform.prop:setVisible ( true )
				view.perform.prop:setString ( "PERFORM!" )
				anim = self:createBounceAnim ( { view.perform }, 1.5 )
				gv:wait ( anim:start () )
				gv.actionShowed ()
				
				app.queue:postEvent ( self, self.E_VIEW.PERFORM )
			end

			local thread = MOAIThread.new ()
			thread:run ( threadFunc )
		end
		
		local anim = self:createBounceAnim ( { smile, view.text }, 2.0, showTimer )
		anim:start ()
	end
	
    view.transform:moveLoc ( dx, -dy, 0.5 )
        :setListener ( MOAIAction.EVENT_STOP,
			function ()
				showContent ()
			end 
		)
end

function GameView:showActionRate ( isMultiplayer, action )
	local gv = self
	
	local dx, dy = 0, - MODEL_SCREEN_H - 397.0 / 2.0
	
	if not self.actionViewRate then
		self.actionViewRate = rm.RSRC_ACTION_RATE:create ()
			:attach ( self.root )
			
		self.actionViewRate.transform:moveLoc ( dx, dy )
	end
	
	self.actionView = self.actionViewRate
	
	local view = self.actionViewRate
	local actionCount = #ACTION_TXT [ true ]
	action = ( action - 1 ) % actionCount + 1
	
	self:setVisible ( view, false )
	
	-- local c = self.wheelView.SECTOR_COLOR [ action ]
	-- view.background.prop:setColor ( c.r / 255, c.g / 255, c.b / 255, 0.8 )	
	view.background.prop:setVisible ( true )
	
	local function setTextSize ( size )
		local style = view.text.prop:getStyle ()
		style:setSize ( size )
		view.text.prop:setStyle ( style )
	end
	
	local function headerStyle ()
		local style = view.text.prop:getStyle ()
		local headerStyle = MOAITextStyle.new ()
		headerStyle:setFont ( style:getFont () )
		headerStyle:setSize ( 50 )
		return headerStyle
	end
	
	local function showContent ()
		-- action = 2
	
		local text = ACTION_TXT [ true ] [ action ]
		setTextSize ( 75 )
		
		if isMultiplayer then
			text = string.format ( "<header>YOUR FRIEND WILL\n\n</>%s", text )
		else
			text = string.format ( "<header>TRY THIS GAME IN A CALL\nAND SEE YOUR FRIEND...\n\n</>%s", text )
		end
		
		view.text.prop:setStyle ( "header", headerStyle () )
		view.text.prop:setVisible ( true )
		view.text.prop:setString ( text )
		
		local function threadFunc ()
			local duration = isMultiplayer and 4.0 or 5.0
			local anim = self:createBounceAnim ( { view.text }, duration )
			gv:wait ( anim:start () )
			
			if isMultiplayer then
				self.isRateShowed = true
				if self.isPerformShowed then
					gv:showRate ()
				end
			else
				gv:hideAction ( 
					function ()
						gv.actionShowed ()
					end )
			end
		end
		
		local thread = MOAIThread.new ()
		thread:run ( threadFunc )			
	end
	
    view.transform:moveLoc ( dx, -dy, 0.5 )
        :setListener ( MOAIAction.EVENT_STOP,
			function ()
				showContent ()
			end 
		)
end

function GameView:showRate ()
	local gv = self

	self.isPerformShowed = true
	
	if not self.isRateShowed then
		return
	end

	assert ( self.actionViewRate )

	local view = self.actionViewRate
	
	local function threadFunc ()
		local function setTextSize ( size )
			local style = view.text.prop:getStyle ()
			style:setSize ( size )
			view.text.prop:setStyle ( style )
		end	

		setTextSize ( 80 )
		view.text.prop:setString ( "RATE\nYOUR\nFRIEND!" )
		local anim = self:createBounceAnim ( { view.text }, 1.0 )
		gv:wait ( anim:start () )
		
		view.btnBad.prop:setVisible ( true )
		view.btnGood.prop:setVisible ( true )
		
		if #self.resultControls == 0 then
			self.resultControls = { view.btnBad, view.btnGood }
			table.insert ( self._inputListeners, view.btnBad )
			table.insert ( self._inputListeners, view.btnGood )
		end
		
		gv.actionShowed ()
	end
	
	av:playSound ( "art/sounds/tick_last.ogg" )
	
	local thread = MOAIThread.new ()
	thread:run ( threadFunc )		
end

function GameView:showResult ( result, callback )
	local gv = self
	
	local dx, dy = 0, - MODEL_SCREEN_H - 397.0 / 2.0
	
	local view
	
	if result then
		if not self.resultViewGood then
			self.resultViewGood = rm.RSRC_RESULT_VIEW_GOOD:create ()
				:attach ( self.root )

			-- self.resultViewGood.background.prop:setColor ( 0.517647, 0.78431372, 0.070588, 0.8 )
			self.resultViewGood.transform:moveLoc ( dx, dy )				
		end
		view = self.resultViewGood
	else
		if not self.resultViewBad then
			self.resultViewBad = rm.RSRC_RESULT_VIEW_BAD:create ()
				:attach ( self.root )
				
			-- self.resultViewBad.background.prop:setColor ( 0.0, 0.0, 0.0, 0.8 )
			self.resultViewBad.transform:moveLoc ( dx, dy )
		end
		view = self.resultViewBad	
	end
	
	local function showContent ()
		local sound = result and "good" or "bad"
		sound = string.format ( "art/sounds/%s.ogg", sound )
		av:playSound ( sound )
	
		gv:showChildren ( view, true )
		
		local messages = RESULT_TXT [ result ]
		local message = messages [ math.random ( #messages ) ]
		
		local style = view.text.prop:getStyle ()
		style:setSize ( message.size )
		view.text.prop:setStyle ( style )
		
		view.text.prop:setString ( message.text )
		
		local function onStop ( self )
			gv:showChildren ( view, false )
			view.background.prop:setVisible ( true )
			
			view.transform:moveLoc ( dx, dy, 0.5 )
				:setListener ( MOAIAction.EVENT_STOP,
					function ()
						if callback then
							callback ()
						end
					end 
				)			
		end
		
		local anim = gv:createBounceAnim ( { view.smile, view.text }, 3.0, onStop )
		
		anim:setListener ( MOAIAction.EVENT_STOP, onStop )
		
		anim:start ()		
	end
	
	gv:showChildren ( view, false )
	view.background.prop:setVisible ( true )
	
	view.transform:moveLoc ( dx, -dy, 0.5 )
		:setListener ( MOAIAction.EVENT_STOP, showContent)
end

function GameView:enableResultControls ( isEnabled )
	for _, btn in ipairs ( self.resultControls ) do
		print ( "\nbtn: " .. tostring ( btn ~= nil ) .. "\n"  )
		btn:setEnabled ( isEnabled )
	end
end

function GameView:showSpin ( speed, rotation )
	if self.wheelView then
		self.wheelView:spin ( speed, rotation )
	end
end

-- function GameView:showPopup ( title, text, span, callback )
    -- if type ( span ) ~= "number" then
        -- callback = span
        -- span = 2.0
    -- end

    -- local popup = DlgPopup.new ( title, text )
    -- popup:show ()

    -- Timer.new ( span - 0.5,
        -- function ()
            -- popup:hide ( callback )
        -- end
    -- ):start ( 1 )
-- end

function GameView:_showDlg ( dlg, span, callback )
    if type ( span ) ~= "number" then
        callback = span
        span = 2.0
    end

    dlg:show ()

    Timer.new ( span,
        function ()
            dlg:hide ( callback )
        end
    ):start ( 1 )
end

function GameView:reset ( isActive )
	self:setFocusVisible ( false )
	self:_setActionVisible ( false )
	
	self.wheelView:reset ()
end

local POPUP_TYPE =
{
	SPIN = 1,
	WAITING_FRIEND = 2,
}

function GameView:showPopup ( popupType, show, callback )
	local gv = self
	local dx, dy = 0, -136.0
	
	if not self.popupTaskQueue then
		self.popupTaskQueue = {}
	end

	local function checkTask ( prev )
		if #self.popupTaskQueue < 1 then
			return
		end
		
		local task = self.popupTaskQueue [ 1 ]
		table.remove ( self.popupTaskQueue, 1 )
		
		function onWaitingFriendHide ()
			gv:onWaitingFriendHide ()
		end
		
		if task.show == prev.show then
			if task.show and task.popupType ~= prev.popupType then
				local callback 
				if prev.popupType == POPUP_TYPE.WAITING_FRIEND then
					callback = onWaitingFriendHide 
				end
				local newTask = { show = not prev.show, callback = callback, popupType = prev.popupType }
				table.insert ( self.popupTaskQueue, 1, task )
				table.insert ( self.popupTaskQueue, 1, newTask ) 
			end
			checkTask ( prev )
		else
			if not task.show and task.popupType ~= prev.popupType then				
				checkTask ( prev )
			else
				self:showPopup ( task.popupType, task.show, task.callback)
			end
		end
		
	end
	
	local task = { show = show, callback = callback, popupType = popupType }
	
	if self.isPopupBusy then
		table.insert ( self.popupTaskQueue, task ) 
		return
	end
	
    if show and self.isPopupHidden then
		self.isPopupBusy = true
		
		self.isPopupHidden = false
		
		if not self.popup then
			self.popup = rm.RSRC_POPUP:create ()
				:attach ( self.root )
			self.popup.transform:moveLoc ( dx, dy )
		end
		
		-- if not self.popupBlinkAnim then
			-- local curve = MOAIAnimCurve.new ()
			-- curve:reserveKeys ( 3 )
			-- curve:setKey ( 1, 0.0, 0.5 )
			-- curve:setKey ( 2, 0.5, 1.0 )
			-- curve:setKey ( 3, 1.0, 0.5 )	
			-- curve:setWrapMode ( MOAIAnimCurve.WRAP )

			-- local anim = MOAIAnim.new ()
			-- anim:reserveLinks ( 1 )
			-- anim:setLink ( 1, curve, self.popup.text.prop, MOAIProp2D.ATTR_A_COL )
			-- anim:setMode ( MOAITimer.CONTINUE )

			-- self.popupBlinkAnim = anim		
		-- end		
		
		local function showContent ()
			gv:showChildren ( self.popup, true )
			if callback then 
				callback () 
			end
			
			self.isPopupBusy = false
			
			self.isPopupVisible = true
			checkTask ( task )
		end
		
		gv:showChildren ( self.popup, false )
		self.popup.background.prop:setVisible ( true )
		
		self.popup.transform:moveLoc ( dx, -dy, 0.5 )
			:setListener ( MOAIAction.EVENT_STOP, showContent )
    end

    if not show and self.isPopupVisible then
		self.isPopupBusy = true
		self.isPopupVisible = false
		if callback then 
			callback () 
		end
		gv:showChildren ( self.popup, false )
		self.popup.background.prop:setVisible ( true )
		
		self.popup.transform:moveLoc ( dx, dy, 0.5 )
			:setListener ( MOAIAction.EVENT_STOP, 
				function ()
					self.isPopupBusy = false
					self.isPopupHidden = true
					checkTask ( task )
				end
			)
    end	
end

function GameView:showSpinPopup ( show )
	local gv = self
	
	local popupType = POPUP_TYPE.SPIN
	
    if show then
		local function onShow ()
			local label = gv.popup.text
			label.prop:setAlignment ( MOAITextBox.CENTER_JUSTIFY, MOAITextBox.CENTER_JUSTIFY )
			label.prop:setString ( "SPIN THE WHEEL!" )
			-- self.popupBlinkAnim:start ()
		end
	
		self:showPopup ( popupType, show, onShow )
    else	
		self:showPopup ( popupType, show )
	end
end

function GameView:onWaitingFriendHide ()
	local gv = self
	if gv.animWaitingFriend then
		gv.animWaitingFriend:stop ()
		gv.animWaitingFriend = nil		
	end
end

function GameView:showWaitingFriend ( show )
	local gv = self
	
	local popupType = POPUP_TYPE.WAITING_FRIEND
	
    if show then
		local function onShow ()
			local label = gv.popup.text		
			
			label.prop:setAlignment ( MOAITextBox.LEFT_JUSTIFY, MOAITextBox.CENTER_JUSTIFY )
			label.prop:setString ( "WAITING FOR FRIEND..." )
			-- self.popupBlinkAnim:start ()
			
			gv.animWaitingFriend = gui.TimelineAction.new
			{
				duration = 2.0;
				loopsCnt = 0;

				{ t = 0.05, function () label.prop:setString ( "WAITING FOR FRIEND" ) end },
				{ t = 0.50, function () label.prop:setString ( "WAITING FOR FRIEND." ) end },
				{ t = 1.00, function () label.prop:setString ( "WAITING FOR FRIEND.." ) end },
				{ t = 1.50, function () label.prop:setString ( "WAITING FOR FRIEND..." ) end },

			}
			gv.animWaitingFriend:start ()	
		end
		self:showPopup ( popupType, show, onShow )
    else
		function onHide ()
			gv:onWaitingFriendHide ()
		end
		self:showPopup ( popupType, show, onHide )
	end
end

function GameView:removeChildren ( widget )
	local children = widget:getChildren ()
	for _, child in ipairs ( children ) do
		child:detach()
	end	
end

function GameView:updateVideoPreview ( hasVideo, force )
	if not force and self.hasVideoPreview == hasVideo then
		return
	end
	
	self.hasVideoPreview = hasVideo
	
	self:removeChildren ( self.root.previewBackground.video )
	
	local previewTexture
	if hasVideo and MOAIVideoTexture then
		previewTexture = rm:rsrc ( gui.VideoTexture ) { type = MOAIVideoTexture.PREVIEW }
	else
		previewTexture = "art/textures/video_placeholder.png"
	end
	
	local RSRC_VIDEO_PREVIEW = rm:rsrc ( gui.Widget, "/preview" )
	{
		deck = rm:rsrc ( gui.GfxQuad )
		{
			rect = { 0, 0, 312, -390 },
			uvRect = { 0, 0, 1, 1 },
			texture = rm:rsrc ( gui.MultiTexture )
			{
				"art/textures/video_mask.png",
				previewTexture,
			}
		},
		
		shader = self:createShader ( "PreviewShader" ),
	}
	
	RSRC_VIDEO_PREVIEW:create ()
		:attach ( self.root.previewBackground.video )	
end

function GameView:updateVideoPlayback ( hasVideo, force )
	if not force and self.hasVideoPlayback == hasVideo then
		return
	end

	self.hasVideoPlayback = hasVideo

	self:removeChildren ( self.root.playbackBackground.video )

	local playbackTexture
	if hasVideo and MOAIVideoTexture then
		playbackTexture = rm:rsrc ( gui.VideoTexture ) { type = MOAIVideoTexture.PLAYBACK }
	else
		playbackTexture = "art/textures/video_placeholder.png"
	end	

	local RSRC_VIDEO_PLAYBACK = rm:rsrc ( gui.Widget, "/playback" )
	{
		deck = rm:rsrc ( gui.GfxQuad )
		{
			rect = { -312, 0, 0, -390 },			
			uvRect = { 0, 0, 1, 1 },	
			texture = rm:rsrc ( gui.MultiTexture )
			{
				"art/textures/video_mask.png",
				playbackTexture,
			}				
		},

		shader = self:createShader ( "PlaybackShader" ),
	}
	
	RSRC_VIDEO_PLAYBACK:create ()
		:attach ( self.root.playbackBackground.video )	
end

function GameView:updateVideoPlaceholders ( videoStatus )
	local root = self.root
	local preview = root.previewBackground
	local playback = root.playbackBackground
	
	preview.text.prop:setVisible ( true )
	playback.text.prop:setVisible ( true )
	
	local function setText ( widget, text )
		if text then
			widget.text.prop:setString ( text )	
		else
			widget.text.prop:setVisible ( false )
		end
	end
	
	local function fade ( widget )
		Timer.new ( 10.0,
			function ()
				widget.text.prop:seekColor ( 0, 0, 0, 0, 2 )
			end
		):start ( 1 )		
	end
	
    if videoStatus == CameraCtrl.NOT_ON_CALL then
        setText ( playback, "TRY\nTHIS GAME\nIN A CALL\nWITH YOUR\nFRIENDS!" )
		setText ( preview )
    elseif videoStatus == CameraCtrl.HOST_TOO_OLD then
        setText ( playback )
		setText ( preview, "UPDATE\nTANGO\nTO VIEW\nVIDEO\nHERE!" )
		fade ( preview )
    elseif videoStatus == CameraCtrl.DEVICE_TOO_OLD then
        setText ( playback )
		setText ( preview, "DEVICE\nNOT\nSUPPORTED" )
		fade ( preview )
    elseif videoStatus == CameraCtrl.VIDEO_SUPPORTED then
        setText ( playback )
		setText ( preview )
    end
end
