av = {}

local defaults =
{
    sampleRate = 44100,
    volume = 1.0,
}

function av:init ( options )
    if MOAIHiAudioSound then
        self._soundsCache = ResourceCache.new (
            function ( filename )
                local snd = MOAIHiAudioSound.new ()
                snd:load ( filename )
                return snd
            end
        )
    elseif MOAIUntzSystem then
        MOAIUntzSystem.initialize ( options.sampleRate or defaults.sampleRate )
        MOAIUntzSystem.setVolume ( options.volume or defaults.volume )

        self._soundsCache = ResourceCache.new (
            function ( filename )
                local snd = MOAIUntzSound.new ()
                snd:load ( filename )
                return snd
            end
        )
    else
        self.playSound = function ( )
            -- do nothing
        end;
    end

end

function av:playSound ( filename, volume )
    if self._soundsCache then
        local snd = self._soundsCache:get ( filename )
        
     --   local snd = MOAIHiAudioSound.new ()
               
        
        if snd then
            snd:setVolume ( volume or 1.0 )
       --      snd:load ( filename )
            snd:play ()
        end
    end
end
