gui:loadSpriteSheet ( "art.textures.animations" )


local TOP_BUTTON_X = 240
local TOP_BUTTON_Y = 410

local BOTTOM_BUTTON_Y = -430

local SCORE_CAPTION_X = 80
local SCORE_CAPTION_Y = TOP_BUTTON_Y + 30


local function imagePath ( source )
    return "art/textures/" .. source
end


rm.RSRC_GAME_VIEW = rm:rsrc ( gui.Widget )
{

    -----------------------------------------------------------------------------
    -- BG
    -----------------------------------------------------------------------------

    rm:rsrc ( gui.Widget )
    {
        x = 0, y = 0;
        scaleX = 2 * RESIZE_SCALE_X; scaleY = 2 * RESIZE_SCALE_Y;

        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("thimbles_bg.png") },
    },

    rm:rsrc ( gui.Widget )
    {
        x = 0, y = -270;
        scaleX = 100.0 * RESIZE_SCALE_X,
        scaleY = 1,
        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("thimbles_floor_gradient.png"), },
    },

    rm:rsrc ( gui.Widget )
    {
        x = 135, y = 388 + TOP_PANEL_OFFSET_Y;
        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("logo_tango.png") },
    },

    rm:rsrc ( gui.Widget )
    {
        x = 3, y = 225 + TOP_PANEL_OFFSET_Y;
        scaleX = 1; scaleY = 1;

        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("thimbles_video_bullets.png") },
    },

    -- round

    rm:rsrc ( gui.ShadowTextBox, "/txtRoundInfo" )
    {
        x = 78, y = -10 + TOP_PANEL_OFFSET_Y;
        font = "art/fonts/futurica80.fnt",
        color = { 0, 0, 0, 1 },
        fontSize = 30,
        rect = {-180, -100, 180, 100,},
        text = "ROUND",
        hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
        YFlip = true,
    },

    rm:rsrc ( gui.ShadowTextBox, "/txtRound" )
    {
        x = 212, y = 7 + TOP_PANEL_OFFSET_Y;
        font = "art/fonts/futurica80.fnt",
        color = { 1, 1, 1, 1 },
        fontSize = 80,
        rect = {-180, -100, 180, 100,},
        text = "1/5",
        hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
        YFlip = true,
    },

    -- bottom BTN

    rm:rsrc ( gui.Widget, "/bottomShade" )
    {
        x = 0, y = -369 - TOP_PANEL_OFFSET_Y;
        scaleX = 1; scaleY = 1;
        deck = rm:rsrc ( gui.GfxQuad ) { texture = "art/textures/thimbles_bottom_shade.png" },
    };

    rm:rsrc ( gui.Button, "/btnBottom" )
    {
        x = 0, y = -430 - TOP_PANEL_OFFSET_Y;
        scaleX = 1; scaleY = 1;
        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("thimbles_lower_bar.png") },

        id = "GameView.btnBottom";

        rm:rsrc ( gui.ShadowTextBox, "/txtStatus" )
        {
            x =  0, y = -110;
            font = "art/fonts/futurica80.fnt",
            color = {1, 1, 1, 1},
            styles = { [ "38" ] = { size = 38, color = { 0, 0, 0, 1 } },
                       [ "45" ] = { size = 45, color = { 0, 0, 0, 1 } } },
            fontSize = 50,
            rect = {-320, 0, 320, 200,},
            text = "<45>TAP TO START GAME</>",
            hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
            YFlip = true,
        },

    },

    rm:rsrc ( gui.ShadowTextBox, "/txtInstructions" )
    {
        x =  0, y = -170 + TOP_PANEL_OFFSET_Y;
        font = "art/fonts/futurica80.fnt",
        color = {1,1,1,1},
        fontSize = 50,
        rect = {-250, 0, 250, 200,},
        text = "",
        hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
        YFlip = true,
    },

    -- X btn
    rm:rsrc ( gui.Button, "/btnExit" )
    {
        x = 270 + TOP_PANEL_OFFSET_X, y = 430 + TOP_PANEL_OFFSET_Y;
        scaleX = 1; scaleY = 1;
        id = "GameView.btnExit";
        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("thimbles_x_body.png") },

        rm:rsrc ( gui.Widget )
        {
            x = -1, y = 1;
            scaleX = 1; scaleY = 1;
            deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("thimbles_x.png") },
        },
    },

    -- X btn
    rm:rsrc ( gui.Button, "/btnInfo" )
    {
        x = -270 - TOP_PANEL_OFFSET_X, y = 430 + TOP_PANEL_OFFSET_Y;
        scaleX = 1; scaleY = 1;
        id = "GameView.btnInfo";
        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("thimbles_x_body.png") },

        rm:rsrc ( gui.Widget )
        {
            x = -1, y = 3;
            scaleX = 1; scaleY = 1;
            deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("thimbles_i.png") },
        },
    },

    rm:rsrc ( gui.Widget, "/playbackBackground" )
    {
        x = -293, y = 440 + TOP_PANEL_OFFSET_Y;

        rm:rsrc ( gui.Widget, "video" )
        {
        },
    },
    
	rm:rsrc ( gui.ShadowTextBox, "/txtFriendScore" )
    {
        x = -70, y = -55 + TOP_PANEL_OFFSET_Y;
        font = "art/fonts/futurica80.fnt",
        color = {255/255, 255/255, 255/255, 1},
        fontSize = 50,
        rect = {-180, 0, 180, 200,},
        text = "",
        hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
        YFlip = true,
    },
	
    rm:rsrc ( gui.ShadowTextBox, "/txtPlaybackMessage" )
    {
        x = -80, y = 220 + TOP_PANEL_OFFSET_Y;
        font = "art/fonts/futurica80.fnt",
        color = { 0.7, 0.7, 0.7, 0.7 },
        fontSize = 40,
        rect = {-280, -200, 280, 200,},
        shadowIntensity = 0,
        text = "",
        hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
        YFlip = true,
    },

    rm:rsrc ( gui.Widget, "/previewBackground" )
    {
        x = 188, y = 216 + TOP_PANEL_OFFSET_Y;

        rm:rsrc ( gui.Widget, "video" )
        {
        },
    },

    rm:rsrc ( gui.ShadowTextBox, "/txtOwnScore" )
    {
        x = 186, y = 35 + TOP_PANEL_OFFSET_Y;
        font = "art/fonts/futurica80.fnt",
        color = {255/255, 255/255, 255/255, 1},
        fontSize = 50,
        rect = {-180, 0, 180, 200,},
        text = "",
        hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
        YFlip = true,
    },
	
    rm:rsrc ( gui.ShadowTextBox, "/txtPreviewMessage" )
    {
        x = 185, y = 220 + TOP_PANEL_OFFSET_Y;
        font = "art/fonts/futurica80.fnt",
        color = { 0.7, 0.7, 0.7, 0.9 },
        fontSize = 30,
        rect = {-280, -200, 280, 200,},
        shadowIntensity = 0,
        text = "MOAI",
        hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
        YFlip = true,
    },
}

rm.RSRC_EXIT_DIALOG = rm:rsrc ( gui.Widget )
{
    x = 220, y = 0;

    rm:rsrc ( gui.Widget, "/fader" )
    {
        x = 200, y = 0;
        scale = 1200,
        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("info_fader.png"),  alignX = 1, },
    },

    --------------------
    -- BG
    --------------------
    rm:rsrc ( gui.Widget )
    {
        scale = 2.0,
        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("thimbles_p_pup.png"),  alignX = 1, },
    },

    rm:rsrc ( gui.ShadowTextBox, "/txtInfo" )
    {
        x =  -215, y = 45;
        font = "art/fonts/futurica80.fnt",
        color = { 1, 1, 1, 1 },
        fontSize = 40,
        rect = {-180, -200, 180, 200,},
        hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
        YFlip = true,
    },

    rm:rsrc ( DlgButton, "/btnYes" )
    {
        x =  -310, y = -118;
        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("dlg_btn.png"), },

        id = "ExitDialog.Yes";

        rm:rsrc ( gui.ShadowTextBox )
        {
            x =  0, y = 0;
            font = "art/fonts/futurica80.fnt",
            color = {0/255, 0/255,0/255,1},
            fontSize = 36,
            rect = {-180, -50, 180, 50,},
            text = "YES",
            hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
            YFlip = true,
        },
    },

    rm:rsrc ( DlgButton, "/btnNo" )
    {
        x =  -127, y = -118;
        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("dlg_btn.png"), },

        id = "ExitDialog.No";

        rm:rsrc ( gui.ShadowTextBox )
        {
            x =  0, y = 0;
            font = "art/fonts/futurica80.fnt",
            color = {0/255,0/255,0/255,1},
            fontSize = 36,
            rect = {-180, -50, 180, 50,},
            text = "NO",
            hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
            YFlip = true,
        },
    },
}

rm.RSRC_VIDEO_DIALOG = rm:rsrc ( gui.Widget )
{
    x = 220, y = 0;

    rm:rsrc ( gui.Widget, "/fader" )
    {
        x = 200, y = 0;
        scale = 1200,
        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("info_fader.png"),  alignX = 1, },
    },

    --------------------
    -- BG
    --------------------
    rm:rsrc ( gui.Widget )
    {
        scale = 2.0,
        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("thimbles_p_pup.png"),  alignX = 1, },
    },

    rm:rsrc ( gui.ShadowTextBox, "/txtInfo" )
    {
        x =  -215, y = 45;
        font = "art/fonts/futurica80.fnt",
        color = { 1, 1, 1, 1 },
        fontSize = 40,
        rect = {-180, -200, 180, 200,},
        hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
        YFlip = true,
    },

    rm:rsrc ( DlgButton, "/btnYes" )
    {
        x =  -310, y = -118;
        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("dlg_btn.png"), },

        id = "EnableVideoDialog.Yes";

        rm:rsrc ( gui.ShadowTextBox )
        {
            x =  0, y = 0;
            font = "art/fonts/futurica80.fnt",
            color = {0/255, 0/255,0/255,1},
            fontSize = 36,
            rect = {-180, -50, 180, 50,},
            text = "YES",
            hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
            YFlip = true,
        },
    },

    rm:rsrc ( DlgButton, "/btnNo" )
    {
        x =  -127, y = -118;
        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("dlg_btn.png"), },

        id = "EnableVideoDialog.No";

        rm:rsrc ( gui.ShadowTextBox )
        {
            x =  0, y = 0;
            font = "art/fonts/futurica80.fnt",
            color = {0/255,0/255,0/255,1},
            fontSize = 36,
            rect = {-180, -50, 180, 50,},
            text = "NO",
            hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
            YFlip = true,
        },
    },
}

rm.RSRC_INFO_DIALOG = rm:rsrc ( gui.Widget )
{
    x = 230, y = 0;

    rm:rsrc ( gui.Widget, "/fader" )
    {
        x = 200, y = 0;
        scale = 1200,
        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("info_fader.png"),  alignX = 1, },
    },

    --------------------
    -- BG
    --------------------
    rm:rsrc ( gui.Widget )
    {
        x = 60, y = 10;
        scaleY = 2.0, scaleX = 2.6,
        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("thimbles_p_pup.png"),  alignX = 1, },
    },

    rm:rsrc ( gui.ShadowTextBox, "/txtInfo" )
    {
        x =  -229, y = 65;
        font = "art/fonts/futurica80.fnt",
        color = { 1, 1, 1, 1},
        fontSize = 38,
        rect = {-240, -300, 240, 300,},
        hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
        YFlip = true,
    },

    rm:rsrc ( DlgButton, "/btnOk" )
    {
        x =  -220, y = -118;
        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("dlg_btn.png"), },

        id = "InfoDialog.Ok";

        rm:rsrc ( gui.ShadowTextBox )
        {
            x =  0, y = 0;
            font = "art/fonts/futurica80.fnt",
            color = {0/255, 0/255,0/255,1},
            fontSize = 36,
            rect = {-180, -50, 180, 50,},
            text = "OK",
            hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
            YFlip = true,
        },
    },
}
