local REFRESH_INTERVAL = 2

CameraCtrl = core.class ( Object )
{
    HOST_TOO_OLD = 1,
    NOT_ON_CALL = 2,
    DEVICE_TOO_OLD = 3,
    VIDEO_SUPPORTED = 4,
    VIDEO_LIVE = 5;
}

function CameraCtrl.videoSupportStatus ()
    if tango then
        local call = tango.videophone.Call_getActiveCall()
        if call then
            local vsc = call:getVideoStreamsControl ()	
			local hasFrontCamera = vsc:hasCamera ( tango.videophone.VideoStreamsControl_CT_FRONT )
			local hasBackCamera = vsc:hasCamera ( tango.videophone.VideoStreamsControl_CT_BACK )
            if vsc:isSendingSupported () and ( hasFrontCamera or hasBackCamera ) then
				if not vsc.isSendingInPrimaryCallUI then
					return CameraCtrl.HOST_TOO_OLD
				end
				
				if vsc:isSendingInPrimaryCallUI () then
					return CameraCtrl.VIDEO_LIVE
				else
					return CameraCtrl.VIDEO_SUPPORTED
				end
            else
                return CameraCtrl.DEVICE_TOO_OLD
            end
        else
            return CameraCtrl.NOT_ON_CALL
        end
    else
        return CameraCtrl.HOST_TOO_OLD
    end
end

function CameraCtrl.getVsc ()
    if CameraCtrl.videoSupportStatus () >= CameraCtrl.DEVICE_TOO_OLD then
        return tango.videophone.Call_getActiveCall():getVideoStreamsControl()
    end
end

function CameraCtrl.enableOutgoingVideo ( )
    if CameraCtrl.videoSupportStatus () >= CameraCtrl.VIDEO_SUPPORTED then
        local vsc = CameraCtrl.getVsc ()
        if vsc:hasCamera ( tango.videophone.VideoStreamsControl_CT_FRONT ) then
            vsc:setSendingCamera ( tango.videophone.VideoStreamsControl_CT_FRONT )
        elseif vsc:hasCamera ( tango.videophone.VideoStreamsControl_CT_BACK ) then
            vsc:setSendingCamera ( tango.videophone.VideoStreamsControl_CT_BACK )
        end
        vsc:startSending ( )
    end
end

function CameraCtrl.observeVideoEnabled ( callback )
    Timer.new ( REFRESH_INTERVAL, function ()
                    callback ( CameraCtrl.getVsc () :isReceiving () )
                                  end ) :start ()
end
