LocalPlayer = core.class ( PlayerCtrl )

function LocalPlayer:ctor ( model, gameView, index )
    PlayerCtrl.ctor ( self, model, gameView, index )
    self.gameView.moveSelected:connect ( self, self.onMoveSelected )
end

function LocalPlayer:dtor ()
    self.gameView.moveSelected:disconnect ( self )
    PlayerCtrl.dtor ( self )
end

function LocalPlayer:activate ()
    assert ( not self.isActive )
    self.isActive = true

    local model = self.model
    local gv = self.gameView

    model:startTurn ()
    if model.state == model.STATE_TURN_COMPLETE then
        -- no turns
        model:finishTurn ()
    else
        gv:setInteractive ( true )
    end
end

function PlayerCtrl:deactivate ()
    -- override
    assert ( self.isActive )
    self.isActive = false
end

function LocalPlayer:onMoveSelected ( move )
    local model = self.model

    if not self.isActive then
        return
    end

    self.gameView:setInteractive ( false )
    model:makeMove ( move )
end
