E_MODEL = Event.declare "Model"
:types
{
    STATE_CHANGED   = 1,
    MOVE_MADE       = 2,
    FRIEND_MOVES    = 3,
}

Model = core.class ( Object )
{
    STATE_INIT              = 0,
    STATE_TURN_BEG          = 1,
    STATE_TURN              = 2,
    STATE_TURN_WAIT_SELECT  = 4,
    STATE_TURN_COMPLETE     = 5,
    STATE_TURN_RESULT	    = 6,
    STATE_TURN_END          = 7,
    STATE_DONE              = 8;

    THIMBLE_SHAFLE_COUNT    = 51,
    MAX_ROUNDS		    = 5,

    _roundWin               = false,
    _score                  = 0,
    _friendScore            = 0,
    _friendFinish	    = false,
    _ballPos                = 3,
    _userSelection          = 0,
    _round                  = 1,
    _movies		    = {},
}

function Model:ctor ()
    self.state = self.STATE_INIT
    self.moveMade = core.signal ()
end

function Model:setup ( )
    assert ( self.state == self.STATE_INIT )
end

function Model:start ( moves )
    assert ( self.state == self.STATE_INIT )
end

function Model:_setState ( nextState )
    local prevState = self.state
    self.state = nextState
    log ( "Model.state %d -> %d", prevState, nextState )
    app.queue:postEvent ( self, E_MODEL.STATE_CHANGED, { prevState = prevState, nextState = nextState })
end

function Model:startTurn ( movies )
    print("start", self.state )
    assert ( self.state == self.STATE_TURN_BEG )
    self._movies = movies
    self:_setState ( self.STATE_TURN )
end

function Model:finishTurn ()
    print("finish", self.state )
    assert ( self.state == self.STATE_TURN_RESULT )
    self:_setState ( self.STATE_TURN_END)
end

function Model:nextTurn ()
    assert ( self.state == self.STATE_TURN_END )
    self._round = self._round + 1
    if self._round > self.MAX_ROUNDS then
        self._round = self.MAX_ROUNDS
        self:_setState ( self.STATE_DONE )
    else
        self:_setState ( self.STATE_TURN_BEG )
    end

end

function Model:waitSelection ()
    assert ( self.state == self.STATE_TURN )
    self:_setState ( self.STATE_TURN_WAIT_SELECT )
end

function Model:selectThimble( thimble )
    assert ( self.state == self.STATE_TURN_WAIT_SELECT )
    self._userSelection = thimble
    self._roundWin = self._ballPos == thimble
    if self._roundWin then
        self._score = self._score + 1
    end
    print("score", self._score)
    self:_setState ( self.STATE_TURN_RESULT )
end

function Model:swapThimble( thimble1, thimble2 )
    if self._ballPos == thimble1 then
        self._ballPos = thimble2
    elseif self._ballPos == thimble2 then
        self._ballPos = thimble1
    end
    print ("Cur Ball poss", self._ballPos)
end

function Model:getRandMove ()
    moves = { }
    for i = 1, self.THIMBLE_SHAFLE_COUNT do
        table.insert ( moves, LCG.random ( 2 ) )
    end
    return moves
end
