
SplashScreen = core.class ( gui.Widget )
{
    CHAR_OFFEST = 97;
	TIMBLE_MOVE_COUNT = 15;
	
}

function SplashScreen:ctor ( rsrc, context, word )
    gui.Widget.ctor ( self, rsrc, context )
    self._isReady = false;
	
    app.queue:subscribe ( self, self.onAnimationEnd, GameView.E_ANIMATED )
	
    
	gui.Widget.new
	{
		deck = rm:rsrc ( gui.GfxQuad )
        {
            texture = "art/textures/thimbles_bg.png";
            scaleX = 8, scaleY = 8 * RESIZE_SCALE_Y;
        },
		
		rm:rsrc ( gui.Widget )
		{
			x = -250, y = 240;
			scaleX = 2; scaleY = 2;
			rotation = 20.0;
			color = {0.22,0.22,0.22,0.22},
			deck = rm:rsrc ( gui.GfxQuad ) { sprite = "thimble_mov0005.png" },
		},
		
		
		rm:rsrc ( gui.Widget )
		{
			x = 100, y = 380;
			scaleX = 1; scaleY = 1;
			rotation = -15.0;
			color = {0.22,0.22,0.22,0.22},
			deck = rm:rsrc ( gui.GfxQuad ) { sprite = "thimble_mov0005.png" },
		},
		
		rm:rsrc ( gui.Widget )
		{
			x = 250, y = 170;
			scaleX = 1.5; scaleY = 1.5;
			rotation = -30.0;
			color = {0.22,0.22,0.22,0.22},
			deck = rm:rsrc ( gui.GfxQuad ) { sprite = "thimble_mov0005.png" },
		},
		
		rm:rsrc ( gui.Widget )
		{
			x = -300, y = -400;
			scaleX = 2; scaleY = 2;
			rotation = 40.0;
			color = {0.22,0.22,0.22,0.22},
			deck = rm:rsrc ( gui.GfxQuad ) { sprite = "thimble_mov0005.png" },
		},
		
		rm:rsrc ( gui.Widget )
		{
			x = 200, y = -350;
			scaleX = 1; scaleY = 1;
			rotation = -25.0;
			color = {0.22,0.22,0.22,0.22},
			deck = rm:rsrc ( gui.GfxQuad ) { sprite = "thimble_mov0005.png" },
		},

		rm:rsrc ( gui.Widget )
		{
			x = 0, y = 150;
			scaleX = 2; scaleY = 2;
			deck = rm:rsrc ( gui.GfxQuad ) { texture = "art/textures/splash_logo.png" },
		},

                rm:rsrc ( gui.Widget )
		{
                    x = - 175 - TOP_PANEL_OFFSET_X, y = 400 + TOP_PANEL_OFFSET_Y;
                    deck = rm:rsrc ( gui.GfxQuad ) { texture = "art/textures/logo_moai.png" },
		},
		

	}:attach ( self )

    self._thimble = {}
    
    for i = 1, 3 do 
        local tm = Thimble.new
        {
            x = -200 + 200 * ( i - 1 ), y = -210;
            scale = 1.0,
        }:attach ( self ) 
        table.insert(self._thimble, tm)
    end
	-- start animation
    self._movies = { }
    for i = 1,self.TIMBLE_MOVE_COUNT do
        table.insert(self._movies, math.random (1,2) )
    end
    self._CurMove = 0
--	av:playSound("art/sounds/slide.ogg")
    self:NextMoveAnimation ()
end


function SplashScreen:onAnimationEnd ( sender, event, args  )
	
	--print("splash ani end")
	
    if event == GameView.E_ANIMATED.THIMBLE_MOVE then
			
        self._MoveAniCount = self._MoveAniCount - 1
        if self._MoveAniCount ~= 0 then
            return
        end
		
        self._thimble[1].transform:setLoc ( -200, -210 );
        self._thimble[2].transform:setLoc ( 0, -210 );
        self._thimble[3].transform:setLoc ( 200, -210 );
        if self._CurMove >= self.TIMBLE_MOVE_COUNT then
			app.queue:postEvent ( nil, GameView.E_ANIMATED.SPLASH_MOVE_END, {})	
        else
			self:NextMoveAnimation ()
		end
    end
end


function SplashScreen:NextMoveAnimation()
    self._CurMove = self._CurMove + 1
    self._MoveAniCount = 2
    
    local move_type = self._movies[self._CurMove]
	
    if move_type == 1 then
        self._thimble[1]:moveTo(-200, 0, 2 )
        self._thimble[2]:moveTo(0, -200, 1 )
    end
	
    if move_type == 2 then
        self._thimble[2]:moveTo(0, 200, 2 )
        self._thimble[3]:moveTo(200, 0, 1 )
    end
	av:playSound("art/sounds/slide.ogg")	
end


function SplashScreen:showWaitMsg ( )
	
    self.waitTextShade = gui.TextBox.new
	{
		x = 82, y = -358;
		font = "art/fonts/futurica80.fnt",
		color = {0,0,0,0.5},
		fontSize = 42,
		rect = {-300, -100, 300, 100,},
		text = "WAITING FOR FRIEND...",
		textAlignX = MOAITextBox.LEFT_JUSTIFY, textAlignY = MOAITextBox.CENTER_JUSTIFY;
		YFlip = true,
	}:attach ( self )  
	
    self.waitText = gui.TextBox.new
	{
		x = 80, y = -360;
		font = "art/fonts/futurica80.fnt",
		color = {1,1,1,1},
		fontSize = 42,
		rect = {-300, -100, 300, 100,},
		text = "WAITING FOR FRIEND...",
		textAlignX = MOAITextBox.LEFT_JUSTIFY, textAlignY = MOAITextBox.CENTER_JUSTIFY;
		YFlip = true,
	}:attach ( self )  

	self.dotShows = 0

	self.timer = Timer.new ( 0.75,
        function ()
            self.dotShows = self.dotShows + 1
			
            if self.dotShows > 3 then
                self.dotShows = 1
            end
			
			local str = "WAITING FOR FRIEND"..string.rep(".",self.dotShows)
			if self.waitText ~= nil then
				self.waitText.prop:setString (  str )
				self.waitTextShade.prop:setString (  str )
			end
        end
    ):start ( 180 )
end

function SplashScreen:dtor ( )
    for _,p in ipairs(self._thimble) do
        p:detach ()
    end
end

function SplashScreen:hide ( )
	local controls = self:getChildren ();
	
    app.queue:unsubscribe ( self, self.onAnimationEnd, GameView.E_ANIMATED )
	
   -- for _,p in ipairs(self._thimble) do
   --     p:detach ()
   -- end
	
	if self.timer ~= nil then
		self.timer:stop ()
		self.timer = nil
	end
	
	local action = nil
	
    for n, p in ipairs(controls) do
      --  print(n)
		if p.prop ~= nil then
			action = p.prop:seekColor ( 0, 0, 0, 0.0, 1.0 )
		end
    end
	
	if action ~= nil then
		action:setListener ( MOAIAction.EVENT_STOP, self.hideDone )
	else
		self:hideDone ()
	end
	
end

function SplashScreen:hideDone ( )
	print("HIDE DONE")
	app.queue:postEvent ( nil, GameView.E_ANIMATED.SPLASH_DONE, { done = true, })	
end




  
  
  
