
Thimble = core.class ( gui.Widget )

function Thimble:ctor ( rsrc, context )
    gui.Widget.ctor ( self, rsrc, context )

    self._shadowHolder = gui.Widget.new
    { }:attach ( self )
    
    self._shadow = gui.Widget.new
    {
        x = -55, y = -60;
		scaleX = 2; scaleY = 2.5;
		deck = rm:rsrc ( gui.GfxQuad ) { texture = "art/textures/thimbles_shadow.png" },
    }:attach ( self )

    self._ballShadow = gui.Widget.new
    {
        x = 0, y = -75;
        scaleX = 2; scaleY = 2.5;
        deck = rm:rsrc ( gui.GfxQuad ) { texture = "art/textures/thimbles_shadow.png" },
        color = { 1, 1, 1, 0.3 },
    }

    self._glow = gui.Widget.new
    {
        x = 8, y = 11;
        -- color = { 0.5, 0.5, 0.5, 0.5 };
        scaleX = 1; scaleY = 1;
        deck = rm:rsrc ( gui.GfxQuad ) { texture = "art/textures/thimbles_glow.png" },
    }

    self._thimble = gui.Widget.new
    {
		x = 0, y = 0;
		scaleX = 1; scaleY = 1;
		deck = rm:rsrc ( gui.GfxQuadDeck )
		{
			"thimble_mov0005.png",
			"thimble_mov0010.png",
			"thimble_mov0015.png",
			"thimble_mov0020.png",
			"thimble_mov0025.png",
			"thimble_mov0030.png",
			"thimble_mov0035.png",
			"thimble_mov0040.png",
			"thimble_mov0045.png",
			"thimble_mov0050.png",
			"thimble_mov0055.png",
			"thimble_mov0060.png",
			"thimble_mov0065.png",
			"thimble_mov0070.png",
			"thimble_mov0075.png",
			"thimble_mov0080.png",
			"thimble_mov0085.png",
			"thimble_mov0090.png",
			"thimble_mov0095.png",
			"thimble_mov0100.png",
		},
--		deck = rm:rsrc ( gui.GfxQuad ) { texture = "art/textures/thimbles_thimbl_1.png" },
    }:attach ( self )

    self._ballShadowAttached = false
end

function Thimble:setModel ( model )
	self.model = model
end

function Thimble:showBall ( animated, callback )
    if not self._ballShadowAttached then
        self._ballShadowAttached = true
        self._ballShadow:attach ( self._shadowHolder )
    end

    if animated then
        local anim = self:indexAnimation( self._thimble.prop, 1, 20, 1 )
        anim:setMode ( MOAITimer.NORMAL )
        anim:setListener ( MOAIAction.EVENT_STOP,
                           function ()
                               Timer.new ( 0.1, self.showBallDone ):start ( 1 )
                               if callback then
                                   callback ()
                               end
                           end
        )
        anim:start ()

        local mode = MOAIEaseType.LINEAR
	local xLoc, yLoc = self._shadow.transform:getLoc ()
        local xLocB, yLocB = self._ballShadow.transform:getLoc ()
        local mode = MOAIEaseType.LINEAR

        local curveY = MOAIAnimCurve.new ()
        local curveX = MOAIAnimCurve.new ()
        local curveYb = MOAIAnimCurve.new ()
        local curveXb = MOAIAnimCurve.new ()
        local curveA = MOAIAnimCurve.new ()
        local curveAb = MOAIAnimCurve.new ()
        curveY:reserveKeys ( 3 )
        curveX:reserveKeys ( 3 )
        curveA:reserveKeys ( 3 )
        curveYb:reserveKeys ( 3 )
        curveXb:reserveKeys ( 3 )
        curveAb:reserveKeys ( 3 )

        curveY:setKey ( 1, 0, yLoc, mode )
        curveY:setKey ( 2, 0.5, yLoc + 10, mode )
        curveY:setKey ( 3, 1, yLoc + 10, mode )
        curveX:setKey ( 1, 0, xLoc, mode )
        curveX:setKey ( 2, 0.5, xLoc - 10, mode )
        curveX:setKey ( 3, 1, xLoc - 10, mode )
        curveA:setKey ( 1, 0, 1, mode )
        curveA:setKey ( 2, 0.5, 0.8, mode )
        curveA:setKey ( 3, 1, 0.8, mode )

        curveYb:setKey ( 1, 0, yLocB, mode )
        curveYb:setKey ( 2, 0.6, yLocB, mode )
        curveYb:setKey ( 3, 1, yLocB - 25, mode )
        curveXb:setKey ( 1, 0, xLocB, mode )
        curveXb:setKey ( 2, 0.6, xLocB, mode )
        curveXb:setKey ( 3, 1, xLocB - 55, mode )
        curveAb:setKey ( 1, 0, 0.7, mode )
        curveAb:setKey ( 2, 0.2, 0.7, mode )
        curveAb:setKey ( 3, 0.7, 1, mode )

        local animS = MOAIAnim.new ()
        animS:reserveLinks ( 6 )
        animS:setLink ( 1, curveY, self._shadow.prop, MOAIProp2D.ATTR_Y_LOC )
        animS:setLink ( 2, curveX, self._shadow.prop, MOAIProp2D.ATTR_X_LOC )
        animS:setLink ( 3, curveA, self._shadow.prop, MOAIProp2D.ATTR_A_COL )
        animS:setLink ( 4, curveYb, self._ballShadow.prop, MOAIProp2D.ATTR_Y_LOC )
        animS:setLink ( 5, curveXb, self._ballShadow.prop, MOAIProp2D.ATTR_X_LOC )
        animS:setLink ( 6, curveAb, self._ballShadow.prop, MOAIProp2D.ATTR_A_COL )
        animS:setMode ( MOAITimer.NORMAL )

        animS:setListener ( MOAIAction.EVENT_STOP,
                            function ()
                                Timer.new ( 0.01, function ()
                                                self:showBall ( false )
                                                  end ):start ( 1 )
                            end
	)

        animS:start ()
    else
        self._thimble.prop:setIndex(20)
        self._shadow.prop:setLoc ( -65, -50 )
        self._shadow.prop:setColor ( 1, 1, 1, 0.8 )
        self._ballShadow.prop:setLoc ( -55, -100 )
        self._ballShadow.prop:setColor ( 1, 1, 1, 1 )
    end
end


function Thimble:acceptsTouch ( x, y )
    return self._thimble.prop:inside ( x, y )
end

function Thimble:showBallDone ( )
	app.queue:postEvent ( nil, GameView.E_ANIMATED.BALL_SHOW, {})
end

function Thimble:hideBall( animated )
    if animated then
        local anim = self:indexAnimation( self._thimble.prop, 20, 1, 1 )
        anim:setMode ( MOAITimer.NORMAL )
        anim:setListener ( MOAIAction.EVENT_STOP,
                           function ()
                               Timer.new ( 0.1, self.hideBallDone ):start ( 1 )
			end
        )
        anim:start ()

        local mode = MOAIEaseType.LINEAR
	local xLoc, yLoc = self._shadow.transform:getLoc ()
        local xLocB, yLocB = self._ballShadow.transform:getLoc ()
        local mode = MOAIEaseType.LINEAR

        local curveY = MOAIAnimCurve.new ()
        local curveX = MOAIAnimCurve.new ()
        local curveYb = MOAIAnimCurve.new ()
        local curveXb = MOAIAnimCurve.new ()
        local curveA = MOAIAnimCurve.new ()
        local curveAb = MOAIAnimCurve.new ()
        curveY:reserveKeys ( 3 )
        curveX:reserveKeys ( 3 )
        curveA:reserveKeys ( 3 )
        curveYb:reserveKeys ( 3 )
        curveXb:reserveKeys ( 3 )
        curveAb:reserveKeys ( 3 )

        curveY:setKey ( 1, 0, yLoc, mode )
        curveY:setKey ( 2, 0.5, yLoc, mode )
        curveY:setKey ( 3, 1, yLoc - 10, mode )
        curveX:setKey ( 1, 0, xLoc, mode )
        curveX:setKey ( 2, 0.5, xLoc, mode )
        curveX:setKey ( 3, 1, xLoc + 10, mode )
        curveA:setKey ( 1, 0, 0.8, mode )
        curveA:setKey ( 2, 0.5, 0.8, mode )
        curveA:setKey ( 3, 1, 1, mode )

        curveYb:setKey ( 1, 0, yLocB, mode )
        curveYb:setKey ( 2, 0.4, yLocB + 20, mode )
        curveYb:setKey ( 3, 1, yLocB + 20, mode )
        curveXb:setKey ( 1, 0, xLocB, mode )
        curveXb:setKey ( 2, 0.4, xLocB + 50, mode )
        curveXb:setKey ( 3, 1, xLocB + 50, mode )
        curveAb:setKey ( 1, 0, 1, mode )
        curveAb:setKey ( 2, 0.2, 1, mode )
        curveAb:setKey ( 3, 0.7, 0.7, mode )

        local animS = MOAIAnim.new ()
        animS:reserveLinks ( 6 )
        animS:setLink ( 1, curveY, self._shadow.prop, MOAIProp2D.ATTR_Y_LOC )
        animS:setLink ( 2, curveX, self._shadow.prop, MOAIProp2D.ATTR_X_LOC )
        animS:setLink ( 3, curveA, self._shadow.prop, MOAIProp2D.ATTR_A_COL )
        animS:setLink ( 4, curveYb, self._ballShadow.prop, MOAIProp2D.ATTR_Y_LOC )
        animS:setLink ( 5, curveXb, self._ballShadow.prop, MOAIProp2D.ATTR_X_LOC )
        animS:setLink ( 6, curveAb, self._ballShadow.prop, MOAIProp2D.ATTR_A_COL )
        animS:setMode ( MOAITimer.NORMAL )

        animS:setListener ( MOAIAction.EVENT_STOP,
                            function ()
                                Timer.new ( 0.01, function ()
                                                self:hideBall ( false )
                                                  end ):start ( 1 )
                            end
	)

        animS:start ()
    else
        if self._ballShadowAttached then
            self._ballShadowAttached = false
            self._ballShadow:detach ()
        end

        self._thimble.prop:setIndex(1)
        self._shadow.prop:setLoc ( -55, -60 )
        self._shadow.prop:setColor ( 1, 1, 1, 1 )

        self._ballShadow.prop:setLoc ( 0, -75 )
        self._ballShadow.prop:setColor ( 1, 1, 1, 0.3 )
    end
end

function Thimble:hideBallDone ( )
	app.queue:postEvent ( nil, GameView.E_ANIMATED.BALL_HIDE, {})
end

function Thimble:moveTo ( src, des, style )
    local yLoc = -210
    local mode = MOAIEaseType.LINEAR
    local steps = 50
    local move_time = 0.25
    local difficulties = { 0.205, 0.185, 0.165, 0.155, 0.145 }

    if self.model ~=nil and self.model._round ~= 0 then
        move_time = difficulties [ self.model._round ]
    end

    local curveX = MOAIAnimCurve.new ()
    curveX:reserveKeys ( steps )
    local curveY = MOAIAnimCurve.new ()
    curveY:reserveKeys ( steps )

    for j = 1, steps do
		local part = j / steps
		local time = move_time * part
		local x = src + ( des - src ) * part
		local y = 50 * math.sin ( math.pi * part )
		y = style == 2 and y or -y
		y = y + yLoc

        curveX:setKey ( j, time, x, mode )
        curveY:setKey ( j, time, y, mode )
	end

    local anim = MOAIAnim.new ()
    anim:reserveLinks ( 2 )
    anim:setLink ( 1, curveX, self.transform, MOAIProp2D.ATTR_X_LOC )
    anim:setLink ( 2, curveY, self.transform, MOAIProp2D.ATTR_Y_LOC )
    anim:setMode ( MOAITimer.NORMAL )
	anim:setListener ( MOAIAction.EVENT_STOP,
		function ()
			Timer.new ( 0.01, self.moveToDone ):start ( 1 )
		end
	)
    anim:start ()
end

function Thimble:moveToDone ( )
--	print("End")
	app.queue:postEvent ( nil, GameView.E_ANIMATED.THIMBLE_MOVE, {})
end


function Thimble:indexAnimation ( target, from, to, length )
    local curve = MOAIAnimCurve.new ()
	local n = to - from
	n = n >= 0 and n + 1 or n * -1 + 1

    curve:reserveKeys ( n )
    local idx = from
    local t = 0.0
    local dt = length / n
    for i = 1, n do
        curve:setKey (i, t, idx, MOAIEaseType.FLAT)
        t = t + dt
        idx = from > to and idx - 1 or idx + 1
    end

   -- curve:setKey ( n + 1, length, n, MOAIEaseType.FLAT )

    local anim = MOAIAnim:new ()
    anim:reserveLinks ( 1 )
    anim:setLink ( 1, curve, target, MOAIProp2D.ATTR_INDEX )
    return anim
end

function Thimble:showEmptyThimble()
	local xLoc, yLoc = self._thimble.transform:getLoc ()
	local xLocS, yLocS = self._shadow.transform:getLoc ()
    local mode = MOAIEaseType.LINEAR
    local steps = 25
	local move_time = 0.5

    local curveY = MOAIAnimCurve.new ()
    local curveXs = MOAIAnimCurve.new ()
    local curveYs = MOAIAnimCurve.new ()
    local curveYsd = MOAIAnimCurve.new ()
    local curveA = MOAIAnimCurve.new ()
    curveY:reserveKeys ( steps * 2 )
    curveXs:reserveKeys ( steps * 2 )
    curveYs:reserveKeys ( steps * 2 )
    curveYsd:reserveKeys ( steps * 2 )
    curveA:reserveKeys ( steps * 2 )

    local dy = 50
    local dySh = 15
    for j = 1, steps do
        local part = j / steps
        local time = move_time * part
        local y = yLoc + dy * part
        curveY:setKey ( j, time, y, mode )

        y = yLocS + dySh * part
        curveYsd:setKey ( j, time, y, mode )
        y = 2.0 + 0.5 * part
        curveXs:setKey ( j, time, y, mode )
        y = 2.5 + 0.5 * part
        curveYs:setKey ( j, time, y, mode )
        curveA:setKey ( j, time, 1 - ( j / steps ) * 0.2, mode )
    end


    for j = 1, steps do
        local part = j / steps
        local time = move_time + move_time * part
        local y = ( yLoc + dy ) - dy * part
        curveY:setKey ( steps + j, time, y, mode )

        y = ( yLocS + dySh ) - dySh * part
        curveYsd:setKey ( steps + j, time, y, mode )
        y = 2.5 - 0.5 * part
        curveXs:setKey ( steps + j, time, y, mode )
        y = 3.0 - 0.5 * part
        curveYs:setKey ( steps + j, time, y, mode )
        curveA:setKey ( steps + j, time, 0.8 + ( j / steps ) * 0.2, mode )
    end

    local animS = MOAIAnim.new ()
    animS:reserveLinks ( 4 )
    animS:setLink ( 1, curveXs, self._shadow.prop, MOAIProp2D.ATTR_X_SCL )
    animS:setLink ( 2, curveYs, self._shadow.prop, MOAIProp2D.ATTR_Y_SCL )
    animS:setLink ( 3, curveYsd, self._shadow.prop, MOAIProp2D.ATTR_Y_LOC )
    animS:setLink ( 4, curveA, self._shadow.prop, MOAIProp2D.ATTR_A_COL )
    animS:setMode ( MOAITimer.NORMAL )

	--ATTR_Z_ROT

    local anim = MOAIAnim.new ()
    anim:reserveLinks ( 1 )
    anim:setLink ( 1, curveY, self._thimble.prop, MOAIProp2D.ATTR_Y_LOC )
    anim:setMode ( MOAITimer.NORMAL )
	anim:setListener ( MOAIAction.EVENT_STOP,
		function ()
			Timer.new ( 0.01, self.showEmptyThimbleDone ):start ( 1 )
		end
	)
	animS:start ()
    anim:start ()
end

function Thimble:showEmptyThimbleDone()
	app.queue:postEvent ( nil, GameView.E_ANIMATED.EMPTY_THIMBLE_SHOW, {})
end

function Thimble:startHighlight ()
    self._glowAnimated = true
    self._glow:attach ( self )

    self._glowAnim = function ()
        local curveA = MOAIAnimCurve.new ()
        local steps = 25
        local move_time = 0.75
        local mode = MOAIEaseType.LINEAR
        curveA:reserveKeys ( steps * 2 )

        for j = 1, steps do
            local part = j / steps
            local time = move_time * part
            curveA:setKey ( j, time, 1 - ( j / steps ), mode )
        end

        for j = 1, steps do
            local part = j / steps
            local time = move_time + move_time * part
            curveA:setKey ( steps + j, time, ( j / steps ), mode )
        end

        local anim = MOAIAnim.new ()
        anim:reserveLinks ( 4 )
        anim:setLink ( 1, curveA, self._glow.prop, MOAIProp2D.ATTR_R_COL )
        anim:setLink ( 2, curveA, self._glow.prop, MOAIProp2D.ATTR_G_COL )
        anim:setLink ( 3, curveA, self._glow.prop, MOAIProp2D.ATTR_B_COL )
        anim:setLink ( 4, curveA, self._glow.prop, MOAIProp2D.ATTR_A_COL )
        anim:setMode ( MOAITimer.NORMAL )
        anim:setListener ( MOAIAction.EVENT_STOP,
                           function ()
                               if self._glowAnimated == true then
                                   Timer.new ( 0.01, self._glowAnim ):start ( 1 )
                               end
                           end )
        anim:start ()
    end

    self._glowAnim ()
end

function Thimble:stopHighlight ()
    self._glow:detach ()
    self._glowAnimated = false
end
