gui:loadSpriteSheet ( "art.textures.buttons" )


local TOP_BUTTON_X = 240
local TOP_BUTTON_Y = 410

local BOTTOM_BUTTON_Y = -430

local SCORE_CAPTION_X = 80
local SCORE_CAPTION_Y = TOP_BUTTON_Y + 30


local function imagePath ( source )
	return "art/textures/" .. source
end

local function populateBgBottom ()
    local rsrc = {}
    local offset = 45

    for i = 1, 6 do
        rsrc [ i ] = rm:rsrc ( gui.Widget )
        {
            x = offset * i, y = - 280 -TOP_PANEL_OFFSET_Y - INPUT_BG_OFFSET;
			scaleX = 4.0, scaleY = 4.0 * RESIZE_SCALE_INPUT_BG_Y_FACTOR;
		    deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("blue_bg_bottom.png"), },
        }
    end

    offset = -45
    for i = 1, 6 do
        rsrc [ 6 + i ] = rm:rsrc ( gui.Widget )
        {
            x = offset * i, y = - 280 -TOP_PANEL_OFFSET_Y - INPUT_BG_OFFSET;
			scaleX = 4.0, scaleY = 4.0 * RESIZE_SCALE_INPUT_BG_Y_FACTOR;
		    deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("blue_bg_bottom.png"), },
        }
    end


    rsrc [ 13 ] = rm:rsrc ( gui.Widget )
        {
            x = 0, y = - 280 -TOP_PANEL_OFFSET_Y - INPUT_BG_OFFSET;
			scaleX = 4.0, scaleY = 4.0 * RESIZE_SCALE_INPUT_BG_Y_FACTOR;
		    deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("blue_bg_bottom.png"), },
        }

    return rm:rsrc ( gui.Widget )( rsrc )
end

local function populateBgTop ()
    local rsrc = {}
    local offset = 45

    for i = 1, 6 do
        rsrc [ i ] = rm:rsrc ( gui.Widget )
        {
            x = offset * i, y = 80 - INPUT_BG_OFFSET;
			scaleX = 4.0, scaleY = 4.0 * RESIZE_SCALE_BG_Y_FACTOR;
		    deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("blue_bg_top.png"), },
        }
    end

    offset = -45
    for i = 1, 6 do
        rsrc [ 6 + i ] = rm:rsrc ( gui.Widget )
        {
            x = offset * i, y = 80 - INPUT_BG_OFFSET;
			scaleX = 4.0, scaleY = 4.0 * RESIZE_SCALE_BG_Y_FACTOR;
		    deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("blue_bg_top.png"), },
        }
    end

    rsrc [ 13 ] = rm:rsrc ( gui.Widget )
        {
            x = 0, y = 80 - INPUT_BG_OFFSET;
			scaleX = 4.0, scaleY = 4.0 * RESIZE_SCALE_BG_Y_FACTOR;
		    deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("blue_bg_top.png"), },
        }

    return rm:rsrc ( gui.Widget )( rsrc )
end

rm.RSRC_GAME_VIEW = rm:rsrc ( gui.Widget )
{
	-----------------------------------------------------------------------------
	-- BG
	-----------------------------------------------------------------------------
    populateBgBottom (),
    populateBgTop (),


	--------------------
	-- BG shadow
	--------------------
	
	rm:rsrc ( gui.Widget )
	{
		x = 0, y = TOP_PANEL_OFFSET_Y;
		scaleX = 4; scaleY = 4;
		
		deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("ww_shadow_main_border.png"),  alignX = 1, },
	},

	rm:rsrc ( gui.Widget )
	{
		x = 0, y = TOP_PANEL_OFFSET_Y;
		scaleX = -4; scaleY = 4;
		
		deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("ww_shadow_main_border.png"), alignX = 1, },
	},


	rm:rsrc ( gui.Widget )
	{
		x = -280, y = -140;
		scaleX = 2; scaleY = 2 * RESIZE_SCALE_BORDER_Y_FACTOR;
		deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("game_bg_middel.png"),  alignX = 1,  alignY = 0; },
	},

	rm:rsrc ( gui.Widget )
	{
		x = 280, y = -140;
		scaleX = -2; scaleY = 2 * RESIZE_SCALE_BORDER_Y_FACTOR;
		deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("game_bg_middel.png"),  alignX = 1, alignY = 0; },
	},

	-- TOP
	rm:rsrc ( gui.Widget )
	{
		x = 0, y = TOP_PANEL_OFFSET_Y;
		scaleX = 1, scaleY = 1;
		
		rm:rsrc ( gui.Widget )
		{
			x = 0, y = 240;
			scaleX = 2; scaleY = 2;
			deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("game_bg_top.png"),  alignX = 1,  alignY = 0; },
		},

		rm:rsrc ( gui.Widget )
		{
			x = 0, y = 240;
			scaleX = -2; scaleY = 2;
			deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("game_bg_top.png"),  alignX = 1, alignY = 0; },
		},
		
		rm:rsrc ( MenuButton, "/btnInfo" )
		{
			x =  -TOP_BUTTON_X, y = TOP_BUTTON_Y;

			deck = rm:rsrc ( gui.GfxQuadDeck )
			{
				[ gui.Button.REGULAR ] =
				{ sprite = "btn_menu_regular.png"; },

				[ gui.Button.PRESSED ] =
				{ sprite = "btn_menu_pressed.png"; },
			},


			id = "GameView.Info";

			-- Text
			rm:rsrc ( gui.Widget, "caption" )
			{
				x = 0, y = 10;
				deck = rm:rsrc ( gui.GfxQuad ) { sprite = "btn_menu_i.png", },
			};
		},
		
		rm:rsrc ( MenuButton, "/btnExit" )
		{
			scaleX = -1;
			x =  TOP_BUTTON_X, y = TOP_BUTTON_Y;
		
			deck = rm:rsrc ( gui.GfxQuadDeck )
			{
				[ gui.Button.REGULAR ] =
				{ sprite = "btn_menu_regular.png"; },

				[ gui.Button.PRESSED ] =
				{ sprite = "btn_menu_pressed.png"; },
			},

			id = "GameView.Exit";

			-- Text
			rm:rsrc ( gui.Widget, "caption" )
			{
				scaleX = -1;
				x = 0, y = 10;
				deck = rm:rsrc ( gui.GfxQuad ) { sprite = "btn_menu_x.png", },
			},
		},
		
		rm:rsrc ( gui.Widget, "/scoreInfoYou" )
		{ 
			x = -SCORE_CAPTION_X, y = SCORE_CAPTION_Y;

			deck = rm:rsrc ( gui.GfxQuad ) { sprite = "board_info_you.png", },
		},
		
		rm:rsrc ( gui.Widget, "/scoreInfoFriend" )
		{ 
			x = SCORE_CAPTION_X, y = SCORE_CAPTION_Y;

			deck = rm:rsrc ( gui.GfxQuad ) { sprite = "board_info_friend.png", },
		},
		
	},
	
	-- BOTTOM
	rm:rsrc ( gui.Widget )
	{
		x = 0, y = -TOP_PANEL_OFFSET_Y;
		scaleX = 1, scaleY = 1;
		
		rm:rsrc ( gui.Widget )
		{
			x = 0, y = -380;
			scaleX = 2; scaleY = 2;
			deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("game_bg_bottom.png"),  alignX = 1,  alignY = 0; },
			--deck = rm:rsrc ( gui.GfxStretch ) { texture = imagePath("ww_main_border_half.png"),  alignX = 1,  alignY = 0; },
		},

		rm:rsrc ( gui.Widget )
		{
			x = 0, y = -380;
			scaleX = -2; scaleY = 2;
			deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("game_bg_bottom.png"),  alignX = 1, alignY = 0; },
		},
		
		rm:rsrc ( gui.Widget )
		{ 
			x = -230, y = -425;
			--x = SCORE_CAPTION_X, y = SCORE_CAPTION_Y;
			scale = 2.0;
			deck = rm:rsrc ( gui.GfxQuad ) { sprite = "board_info_time.png", },
		},	
		
		rm:rsrc ( gui.Button, "/btnSubmit" )
		{
			x = 0, y = BOTTOM_BUTTON_Y;

			deck = rm:rsrc ( gui.GfxQuadDeck )
			{
				"btn_submit_regular.png",
				"btn_submit_pressed.png"
			},

			id = "GameView.Submit";
		},

		rm:rsrc ( gui.Button, "/btnShuffle" )
		{
			x = 230, y = BOTTOM_BUTTON_Y;

			deck = rm:rsrc ( gui.GfxQuadDeck )
			{
				"btn_shuffle_regular.png",
				"btn_shuffle_pressed.png",
			},

			id = "GameView.Shuffle";
		},
	},

--[[
	rm:rsrc ( gui.Widget, "/wdgCounter" )
	{
		rm:rsrc ( gui.Widget )
		{
			scale = 1.5,
			deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("popup_bg.png"),  alignX = 0, },
		},
		rm:rsrc ( gui.Widget, "/imgCounter" )
		{
			deck = rm:rsrc ( gui.GfxQuadDeck )
			{
				"count_down_3.png",
				"count_down_2.png",
				"count_down_1.png",
			},
		},
		
		
		rm:rsrc ( gui.TextBox, "/txtCounter" )
		{
			font = "art/fonts/arial_rnd.fnt",
			-- color = {40/255,90/255,166/255,1},
			color = {249/255,208/255,26/255,1},
			fontSize = 80,
			rect = {-180, -100, 180, 100,},
			hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
			YFlip = true,
		},
		
	}
	--]]
}


rm.RSRC_COUNTDOWN_VIEW = rm:rsrc ( gui.Widget )
{
		rm:rsrc ( gui.Widget )
		{
			scale = 1.5,
			deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("popup_bg.png"),  alignX = 0, },
		},
		rm:rsrc ( gui.Widget, "/imgCounter" )
		{
			deck = rm:rsrc ( gui.GfxQuadDeck )
			{
				"count_down_3.png",
				"count_down_2.png",
				"count_down_1.png",
			},
		},
}


rm.RSRC_EXIT_DIALOG = rm:rsrc ( gui.Widget )
{
	x = 220, y = 0;
	
	rm:rsrc ( gui.Widget, "/fader" )
	{
		x = 200, y = 0;
		scale = 1200,
		deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("info_fader.png"),  alignX = 1, },
	},
	
	--------------------
	-- BG
	--------------------
	rm:rsrc ( gui.Widget )
	{
		scale = 2.0,
		deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("popup_bg.png"),  alignX = 1, },
	},
	
	rm:rsrc ( gui.TextBox )
	{
		x =  -210, y = -50;
		font = "art/fonts/arial_rnd.fnt",
		color = {40/255,90/255,166/255,1},
		fontSize = 38,
		rect = {-180, 0, 180, 200,},
		text = "ARE YOUR SURE?",
		hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
		YFlip = true,
	},
	
	
	rm:rsrc ( DlgButton, "/btnYes" )
	{
		x =  -298, y = -80;
		scale = 1.0;
	
        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("btn_dialogs.png"), },

		id = "ExitDialog.Yes";

		-- Text
		rm:rsrc ( gui.Widget, "caption" )
		{
			x = 0, y = 0;
			deck = rm:rsrc ( gui.GfxQuad ) { sprite = "btn_txt_yes.png", },
		},
	},	
	
	rm:rsrc ( DlgButton, "/btnNo" )
	{
		x =  -122, y = -80;
		scale = 1.0;
        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("btn_dialogs.png"), },

		id = "ExitDialog.No";

		-- Text
		rm:rsrc ( gui.Widget, "caption" )
		{
			x = 0, y = 0;
			deck = rm:rsrc ( gui.GfxQuad ) { sprite = "btn_txt_no.png", },
		},
	},	
}

rm.RSRC_INFO_DIALOG = rm:rsrc ( gui.Widget )
{
	x = 220, y = 0;
	--------------------
	-- BG
	--------------------
	
	rm:rsrc ( gui.Widget, "/fader" )
	{
		x = 200, y = 0;
		scale = 1200,
		deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("info_fader.png"),  alignX = 1, },
	},
	
	
	rm:rsrc ( gui.Widget )
	{
		x = 0, y = 0;
		scale = 2.0,
		deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("popup_bg.png"),  alignX = 1, },
	},
	
	rm:rsrc ( gui.TextBox )
	{
		x =  -212, y = -50;
		font = "art/fonts/arial_rnd.fnt",
		color = {40/255,90/255,166/255,1},
		fontSize = 35,
		rect = {-180, -50, 180, 250,},
		text = "TAP THE LETTERS TO CREATE A WORD,\n THEN TAP SUBMIT TO VERIFY THE WORD",
		--Tap the letters to create a word, then tap Submit to verify the word
		hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
		YFlip = true,
	},
	
	rm:rsrc ( DlgButton, "/btnOk" )
	{
		x =  -210, y = -90;
		scale = 1.0;
		
        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("btn_dialogs.png"), },

		id = "InfoDialog.Ok";

		-- Text
		rm:rsrc ( gui.Widget, "caption" )
		{
			x = 0, y = 0;
			deck = rm:rsrc ( gui.GfxQuad ) { sprite = "btn_txt_ok.png", },
		},
	},	
}


rm.RSRC_GAME_OVER_DIALOG = rm:rsrc ( gui.Widget )
{
	x = 220, y = 0;
	--[[
	rm:rsrc ( gui.Widget, "/fader" )
	{
		x = 200, y = 0;

		deck = rm:rsrc ( gui.GfxQuad )
		{
			texture = imagePath("info_fader.png");
		  	alignX = 1;
		  	scaleX = 700, scaleY = 700;
		},
	},
	--]]
	--------------------
	-- BG
	--------------------
	--[[
	rm:rsrc ( gui.Widget, "/wdgWrapper" )
	{
		x = 0, y = 0;

		deck = rm:rsrc ( gui.GfxQuad )
		{
			texture = imagePath("popup_bg.png");
			alignX = 1;
			scaleX = 2.0, scaleY = 2.0;
		},

		rm:rsrc ( gui.TextBox, "/dlgTitle" )
		{
			x =  -213, y = 10;
			font = "art/fonts/arial_rnd.fnt",
			color = {40/255,90/255,166/255,1},
			fontSize = 48,
			rect = {-200, 0, 200, 200,},
			text = "GAME OVER",
			hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
			YFlip = true,
		},
		
		rm:rsrc ( gui.TextBox, "/dlgMyScore" )
		{
			x = -120, y = -60;
			font = "art/fonts/arial_rnd.fnt",
			color = {40/255,90/255,166/255,1},
			fontSize = 32,
			rect = {-400, 0, 0, 200,},
			text = "YOUR SCORE:",
			hAlignment = MOAITextBox.RIGHT_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
			YFlip = true,
		},

		rm:rsrc ( gui.TextBox, "/dlgMyScoreValue" )
		{
			x = -100, y = -55;
			font = "art/fonts/arial_rnd.fnt",
			color = {40/255,90/255,166/255,1},
			fontSize = 48,
			rect = {-10, 0, 50, 200,},
			hAlignment = MOAITextBox.LEFT_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
			YFlip = true,
		},

		rm:rsrc ( gui.TextBox, "/dlgFriendScore" )
		{
			x = -120, y = -105;
			font = "art/fonts/arial_rnd.fnt",
			color = {40/255,90/255,166/255,1},
			fontSize = 32,
			rect = {-400, 0, 0, 200,},
			hAlignment = MOAITextBox.RIGHT_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
			YFlip = true,
		},

		rm:rsrc ( gui.TextBox, "/dlgFriendScoreValue" )
		{
			x = -100, y = -100;
			font = "art/fonts/arial_rnd.fnt",
			color = {40/255,90/255,166/255,1},
			fontSize = 48,
			rect = {-10, 0, 50, 200,},
			hAlignment = MOAITextBox.LEFT_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
			YFlip = true,
		},
		
		rm:rsrc ( gui.TextBox, "/dlgWaitFriend" )
		{
			x =  -215, y = -105;
			font = "art/fonts/arial_rnd.fnt",
			color = {40/255,90/255,166/255,1},
			fontSize = 32,
			rect = {-200, 0, 200, 200,},
			text = "WAITING FOR FRIEND",
			hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
			YFlip = true,
		},

		rm:rsrc ( DlgButton, "/btnOk" )
		{
			x =  -210, y = -95;
			scale = 1.0;
			
	        deck = rm:rsrc ( gui.GfxQuad ) { texture = imagePath("btn_dialogs.png"), },
		
			id = "GameOverDialog.Ok";

			-- Text
			rm:rsrc ( gui.Widget, "caption" )
			{
				x = 0, y = 0;
				deck = rm:rsrc ( gui.GfxQuad ) { sprite = "btn_txt_ok.png", },
			},
		},
	},
	--]]
	rm:rsrc ( gui.TextBox, "/txtInstructions1" )
	{
		x =  -215, y = -230;
		font = "art/fonts/hobo_outline.fnt",
		color = {1,1,1,1},
		fontSize = 52,
		rect = {-275, 0, 275, 200,},
		text = "YOU LOSE",
		hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
		YFlip = true,
	},
	
	rm:rsrc ( gui.TextBox, "/txtInstructions2" )
	{
		x =  -200, y = -285;
		font = "art/fonts/hobo_outline.fnt",
		color = {249/255,208/255,26/255,1},
		fontSize = 28,
		rect = {-250, 0, 250, 200,},
		text = "TAP TO CONTINUE ...",
		hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
		YFlip = true,
	},
	
	rm:rsrc ( gui.TextBox, "/txtInstructions3" )
	{
		x =  -215, y = -255;
		font = "art/fonts/hobo_outline.fnt",
		color = {1,1,1,1},
		fontSize = 46,
		rect = {-275, 0, 275, 200,},
		text = "YOU LOSE",
		hAlignment = MOAITextBox.CENTER_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
		YFlip = true,
	},
	
}




