GameOverDialog = core.class ( gui.Scene )
{
 
}

function GameOverDialog:ctor ( model )
    local root = rm.RSRC_GAME_OVER_DIALOG:create ()
    gui.Scene.ctor ( self, root )

    self.model = model
    self._inputListeners =
    {
        self,
        root.btnOk,
    }

    self.inputBlocked = 0
    self._isActiveTap = false
    self._tapTimer = nil
    self._playSound = true    
    
    local action = self.root.txtInstructions1.transform:moveScl ( 0.05, 0.05, 0.0, 0.35, MOAIEaseType.SOFT_EASE_OUT )
    action:setListener ( MOAIAction.EVENT_STOP, self.textZoomOut )
    action.textZoomCtrl = self.root.txtInstructions1
    
end

function GameOverDialog:show ( )
    self:updateDialog ()
    gui.Scene.show ( self )

   -- self.root.wdgWrapper.transform:moveLoc ( 0, 700)
   -- self.root.fader.prop:setColor ( 0, 0, 0, 0.2 )
end

function GameOverDialog:hide ()
  --  local action = self.root.wdgWrapper.transform:moveLoc ( 0, 700, 0.5 )
  --  self.root.fader.prop:seekColor ( 0, 0, 0, 0.0, 0.5 )
 --   action:setListener ( MOAIAction.EVENT_STOP, self.slideOutDone )
  --  action.dialogInst = self
end

function GameOverDialog:slideOutDone ()
    gui.Scene.hide( self.dialogInst )
end


function GameOverDialog:getInputListeners ()
    if self.inputBlocked == 0 then
        return self._inputListeners
    end
end

function GameOverDialog:onTouchBegan ( sender, event, args )
    local x, y = args.x, args.y

--[[
    if not self._isPopupShown then
        self.root.wdgWrapper.transform:moveLoc ( 0, -700, 0.5 )
        self.root.fader.prop:seekColor ( 0, 0, 0, 0.5, 0.5 )
        self.root.txtInstructions:detach ()

        self._isPopupShown = true
        return
    end
    --]]

    if self._isActiveTap then
        app.queue:postEvent ( self, gui.E_ACTION, { id = "GameOverDialog.Ok" })
    end
end

function GameOverDialog:updateDialog ()
    -- set title
    
    local mp = self.model.isMultiplayer
    local friendAvailable = mp and self.model:getFriendFinish ()
    local isActiveTap = true
    
    if mp then
        
        if friendAvailable and self.model:getFriendScore () == self.model:getPlayerScore () then
            self.root.txtInstructions1.prop:setString ( "TIE" )
        else
            self.root.txtInstructions1.prop:setString ( friendAvailable and ( self.model:getFriendScore () > self.model:getPlayerScore () and "YOU LOSE" or "YOU WIN" )  or "" )
        end
        
        self.root.txtInstructions2.prop:setString ( self._isActiveTap and "TAP TO CONTINUE ..." or "" )
        self.root.txtInstructions3.prop:setString ( ( friendAvailable or self.model:isFindAllWords () ) and "" or "WAITING FOR FRIEND ..." )
        isActiveTap = friendAvailable
        
        if friendAvailable and self._playSound then
            self._playSound = false
            
            if self.model:getFriendScore () > self.model:getPlayerScore () then
                av:playSound("art/sounds/game_lose_s.ogg")
            else
                av:playSound("art/sounds/game_win_s.ogg")
            end
       end
        
    else
        self.root.txtInstructions1.prop:setString ( self.model:isFindAllWords () and "EXCELLENT" or "TIME'S UP" )
        self.root.txtInstructions2.prop:setString ( self._isActiveTap and "TAP TO CONTINUE ..." or "" )
        self.root.txtInstructions3.prop:setString ( "" )
        isActiveTap = true
    end
    
    if self._isActiveTap == false and isActiveTap and self._tapTimer == nil then
        self._tapTimer = Timer.new ( 3.0,
        function ()
            self._isActiveTap = true
            self._tapTimer = nil
            self:updateDialog ()
        end
    ):start ( 1 )
    end
    
    --[[
    if self.model:isFindAllWords () then
        self.root.dlgTitle.prop:setString ( "WELL DONE" )
    else
        self.root.dlgTitle.prop:setString ( "TIME'S UP" )
    end

    local playerTitle1 = self.root.dlgMyScore
    local playerScore1 = self.root.dlgMyScoreValue
    local playerTitle2 = self.root.dlgFriendScore
    local playerScore2 = self.root.dlgFriendScoreValue
    local wdgWait = self.root.dlgWaitFriend

    local mp = self.model.isMultiplayer
    local friendAvailable = mp and self.model:getFriendFinish ()

    playerTitle2.prop:setString ( friendAvailable and "FRIEND SCORE:" or "" )
    playerScore2.prop:setVisible ( friendAvailable and tostring ( self.model:getFriendScore ()) or "" )

    wdgWait.prop:setString (( mp and not friendAvailable ) and "WAITING FOR FRIEND..." or "" )

    if not mp or friendAvailable then
        self.root.btnOk.transform:setLoc ( -210, -95 )
    else
        self.root.btnOk.transform:setLoc ( -1210, -95 )
    end

    playerScore1.prop:setString ( tostring ( self.model:getPlayerScore ()) )
    --]]
end

function GameOverDialog:textZoomOut ( )
    local action = self.textZoomCtrl.transform:moveScl ( -0.05, -0.05, 0.0, 0.35, MOAIEaseType.SOFT_EASE_OUT )
    action:setListener ( MOAIAction.EVENT_STOP, GameOverDialog.textZoomIn )
    action.textZoomCtrl = self.textZoomCtrl
end

function GameOverDialog:textZoomIn ( )
    local action = self.textZoomCtrl.transform:moveScl ( 0.05, 0.05, 0.0, 0.35, MOAIEaseType.SOFT_EASE_OUT)
    action:setListener ( MOAIAction.EVENT_STOP, GameOverDialog.textZoomOut )
    action.textZoomCtrl = self.textZoomCtrl
end

