
InputBoard = core.class ( gui.Widget )

function InputBoard:ctor ( rsrc, context )
    gui.Widget.ctor ( self, rsrc, context )
    _isReady = false;
    
    self.CHAR_OFFEST = 97
end

function InputBoard:createInput ( word )
    
    self._btns = {}
    self.curLetters = {}
    self.curWord = word;
    
    local len = string.len ( word )
    
    for tt = 1, 2 do
        for n = 1, len do
            local tt = WordButton.new
            {
                x = tt == 1 and 600 or (n - 1) * self.CHAR_OFFEST,
                y = tt == 1 and 0 or -1024;
                scale = 1.0;
                deck = rm:rsrc ( gui.GfxQuadDeck )
                {
                    "btn_word_regular.png",
                    "btn_word_pressed.png",
                },

                id = "GameView.Char"..tt.."_"..n;
            
                rm:rsrc ( gui.Widget, "letter" )
                {
                    x = 0, y = 11; 
                    scale = 2.0;
                    index = string.byte(word, n ) - string.byte( "a" ) + 1;
                    deck = rm:rsrc ( gui.TileDeck ) { texture = "art/textures/letters.png",rows = 4, cols = 7; },
                }
            }:attach ( self )
            table.insert(self._btns,tt)
        end
    end
    
    _isReady = false
    -- self:_shuffle ()
    self:slideIn ()    
end

function InputBoard:Shuffle ()
    
    if _isReady == false then
        return false
    end
    
    _isReady = false
    
    self:_shuffleSlideOnBoard ()
    
    return true
    
    --[[
    
    local len = string.len ( self.curWord )
    
    for i = 1, len do
        local btn = self._btns[ i ]  
        local xLoc, yLoc  = btn.transform:getLoc ();
        local action = btn.transform:moveLoc ( -125 * i, 0, 0.15 * i )
        
        if i == len then
            action:setListener ( MOAIAction.EVENT_STOP, self.slideOutDone )
            action.inputViewInst = self
        end
    end
    --]]
 end


function InputBoard:slideOutDone ()
    local selWord = self.inputViewInst:getWord ()
    self.inputViewInst:clearWord ()
    self.inputViewInst:_shuffle ()
    self.inputViewInst:selectWord ( selWord )
    self.inputViewInst:slideIn ()
end

function InputBoard:_shuffleSlideOnBoard ()
    local pos_tmp = {}
    local pos_x_tmp = {}
    
    local len = string.len ( self.curWord )
    for i = 1,len do
        table.insert(pos_tmp, i) 
       
        local btn = self._btns[ i ];
        local xLoc, yLoc  = btn.transform:getLoc ();  
        table.insert(pos_x_tmp, xLoc) 
    end    
    
    for i = 1,len do
        local idx = math.random ( 1, len )
        
        
        pos_tmp[i], pos_tmp[idx] = pos_tmp[idx], pos_tmp[i]
        
        --local tmp = pos_tmp[i];
        --pos_tmp[i] = pos_tmp[idx]
        --pos_tmp[idx] = tmp
    end
    
    --local half_len = math.floor( len / 2 )
    
    for i = 1, len do
        local btn = self._btns[ i ]  
        local new_x_pos = pos_x_tmp[ pos_tmp[i] ] 
        local xLoc, yLoc  = btn.transform:getLoc ();
        local action = btn.transform:moveLoc ( new_x_pos - xLoc, yLoc2, 0.5 )
        
        if i == len then
            action:setListener ( MOAIAction.EVENT_STOP, self.slideOnBoardDone )
            action.inputViewInst = self
        end
    end    
end

function InputBoard:slideOnBoardDone ()
    _isReady = true
end

function InputBoard:_shuffle ()
    local pos_tmp = {}
    local len = string.len ( self.curWord )
    for i = 1,len do
       table.insert(pos_tmp, i) 
    end
    
    for i = 1,len do
        local idx = math.random ( 1, len )
        local tmp = pos_tmp[i];
        pos_tmp[i] = pos_tmp[idx]
        pos_tmp[idx] = tmp
    end
    
    local str = ""
    for n,p in ipairs(pos_tmp) do
        str = str..string.sub(self.curWord,p,p)
    end
    
    self.curWord = str
   -- print(str)
    
    for tt = 1, 2 do
        for n = 1, len do
            local btn = self._btns[ n + ( tt - 1 ) * 6 ]
            local children = btn:getChildren ()
            for _, ch in ipairs ( children ) do
                ch.prop:setIndex(string.byte(self.curWord, n ) - string.byte( "a" ) + 1)
            end
        end
    end
end

function InputBoard:selectWord ( selWord )
    local selLen = string.len (selWord)
    for n = 1,selLen do
        local symbol = string.sub (selWord,n,n)
        local sStart, sEnd = string.find ( self.curWord, symbol)
        self:addLetter (sStart)
    end
end


function InputBoard:slideIn ()
    local len = string.len ( self.curWord )
    for i = 1, len do
        local btn = self._btns[ i ]  
        local xLoc, yLoc  = btn.transform:getLoc ();
        btn.transform:setLoc( 700, yLoc );
        local move_x = self.CHAR_OFFEST * ( i - 1 ) - 700 
        local action = btn.transform:moveLoc ( move_x, 0, 0.15 * i )
        if i == len then
            action:setListener ( MOAIAction.EVENT_STOP, self.slideOnBoardDone )
            action.inputViewInst = self
        end
    end
end

function InputBoard:getBtnCtrls ()
    return self._btns
end
    
    
function InputBoard:addLetter ( char_index )
    local btn = self._btns[char_index]
    
    --btn:setEnabled ( false )
    btn:setState ( gui.Button.PRESSED )
    
    local children = btn:getChildren ()
    for _, ch in ipairs ( children ) do
        ch.transform:setLoc ( 0, 1 )
    end
    
    for n,p in ipairs(self.curLetters) do
        if p == char_index then
           return
        end
    end    
    
    table.insert(self.curLetters,char_index)
    self:_formatCurWord()
end

function InputBoard:remLetter( char_index )
    local btn = self._btns[char_index]
 
   -- btn:setEnabled ( true )
    btn:setState ( gui.Button.REGULAR )
    
    local children = btn:getChildren ()
    for _, ch in ipairs ( children ) do
        ch.transform:setLoc ( 0, 11 )
    end
    
    local btn2 = self._btns[char_index + 6]
    btn2.transform:setLoc ( btn2.rsrc.x, -1024 )
    
    local table_idx = -1
    for n,p in ipairs(self.curLetters) do
        if p == char_index then
           table_idx = n
        end
    end
    table.remove(self.curLetters,table_idx)
    self:_formatCurWord()
end

function InputBoard:getWord()
    local str = ""
    for n,p in ipairs(self.curLetters) do
        str = str..string.sub(self.curWord,p,p)
    end
    
  --  print(str)
    return str
end

function InputBoard:clearWord()
    for n,p in ipairs(self.curLetters) do
        local btn = self._btns[p]
 
        btn:setState ( gui.Button.REGULAR )
        --btn:setEnabled ( false )
    
        local children = btn:getChildren ()
        for _, ch in ipairs ( children ) do
            ch.transform:setLoc ( 0, 11 )
        end  
        
        local btn2 = self._btns[p + 6]
        btn2.transform:setLoc ( btn2.rsrc.x, -1024 )
    end
    self.curLetters = {}
end

function InputBoard:_formatCurWord()
    local CHAR_OFFEST = 97    
    if #self.curLetters == 0 then
        return
    end
    
    local offest_x = CHAR_OFFEST * ( 6 - #self.curLetters ) / 2
    
    for n,p in ipairs(self.curLetters) do
        local btn = self._btns[ 6 + p]
        btn.transform:setLoc( offest_x + CHAR_OFFEST * ( n -1 ), 120 )        
    end
    
    
 --[[   
 x = CHEAT_OFFEST_X + (n - 1) * CHAR_OFFEST,
    for n,p in ipairs(self.curLetters) do
        str = str..string.sub(self.curWord,p,p)
    end
 --]]   
    
end






  
  
  