
SplashScreen = core.class ( gui.Widget )
{
    CHAR_OFFEST = 97;
}

function SplashScreen:ctor ( rsrc, context, word )
    gui.Widget.ctor ( self, rsrc, context )
    self._isReady = false;
    
    self._btns = {}
    self.curWord = word;
    
    
    local len = string.len ( word )
	
	
	gui.Widget.new
	{
		deck = rm:rsrc ( gui.GfxQuad )
        {
            texture = "art/textures/splash_bg.png";
            scaleX = 4, scaleY = 4 * RESIZE_SCALE_Y;
        },

        rm:rsrc ( gui.Widget, "letter" )
        {
            deck = rm:rsrc ( gui.GfxQuad )
            {
				y = 164 + TOP_PANEL_OFFSET_Y,
                texture = "art/textures/ww_splash_stat_top.png";
                scaleX = 4, scaleY = 4;
            },
        },
		
        rm:rsrc ( gui.Widget, "letter2" )
        {
            deck = rm:rsrc ( gui.GfxQuad )
            {
				y = -270 - TOP_PANEL_OFFSET_Y,
                texture = "art/textures/ww_splash_stat_bottom.png";
                scaleX = 4, scaleY = 4;
            },
        },

        rm:rsrc ( gui.Widget )
        {
            x = 300, y = -0.5 * MODEL_SCREEN_H + 20;

            deck = rm:rsrc ( gui.GfxQuad )
            {
                texture = "art/textures/moai_logo.png";
                alignX = 1, alignY = -1;
            };
        },
	}:attach ( self )

    
    for n = 1, len do
        local tt = gui.Button.new
        {
            x = -200 + (n - 1) * self.CHAR_OFFEST,
            y =  0;
            scale = 1.0;
            deck = rm:rsrc ( gui.GfxQuadDeck )
            {
                "btn_word_regular.png",
                "btn_word_pressed.png",
            },

            id = "GameView.Splash_"..n;
            
            rm:rsrc ( gui.Widget, "letter" )
            {
                x = 0, y = 11; 
                scale = 2.0;
                index = string.byte(word, n ) - string.byte( "a" ) + 1;
                deck = rm:rsrc ( gui.TileDeck ) { texture = "art/textures/letters.png",rows = 4, cols = 7; },
            }
        }:attach ( self )
        table.insert(self._btns,tt)
    end
    
    --[[
    for i = 1, len do
        local btn = self._btns[ i ]  
        local xLoc, yLoc  = btn.transform:getLoc ();
        local y_move =  ( ( ( i % 2 ) == 0 ) and 1 or -1 ) * ( 500 * i )
        btn.transform:setLoc(xLoc, y_move );
        local action = btn.transform:moveLoc ( 0, -y_move, 0.55 * i )
    end 
    --]]
    
    
    for i = 1, len do
        
        local btn = self._btns[ i ]  

        local xLoc, yLoc  = btn.transform:getLoc ();
      -- local y_move =  ( ( ( i % 2 ) == 0 ) and 1 or -1 ) * ( 500 * i )
   --    btn.transform:setLoc(xLoc, y_move );
  --     local action = btn.transform:moveLoc ( 0, -y_move, 0.0 )
  
     --   print(i, xLoc, yLoc)
        
        local mode = MOAIEaseType.LINEAR
        local steps = 50 
        
        local curveX = MOAIAnimCurve.new ()
        curveX:reserveKeys ( steps )
        local curveY = MOAIAnimCurve.new ()
        curveY:reserveKeys ( steps )
        
        local curveR = MOAIAnimCurve.new ()
        curveR:reserveKeys ( steps )
        
      --  curveX:setKey ( 1, 0, 0, mode )
    --   curveY:setKey ( 1, 0, -750, mode )
        
        for j = 1, steps do 
            
            --+ i * 3.14 / 6 ) * 1.8
            
            local step = 3.0 * j / steps
            
            local n_step = 3.001 - step
            
            local a = n_step * (  2.0 * math.pi ) * 4.0
            
         --   print( j, step )
            
            curveX:setKey ( j, step, xLoc + ( 200 ) * n_step *  math.cos( 2 * math.pi * n_step + math.pi / 4.0 * i * n_step ), mode )
            curveY:setKey ( j, step, yLoc + ( 200 ) * n_step *  math.sin( 2 * math.pi * n_step  + math.pi / 4.0 * i * n_step ), mode )
            
            curveR:setKey  ( j, step, a  , mode )
        end
        
        curveX:setKey ( steps, 3.1, xLoc, mode )
        curveY:setKey ( steps, 3.1, yLoc, mode )
        curveR:setKey ( steps, 3.1, 0 , mode )


    local anim = MOAIAnim.new ()
    anim:reserveLinks ( 3 )
    anim:setLink ( 1, curveX, btn.prop, MOAIProp2D.ATTR_X_LOC )
    anim:setLink ( 2, curveY, btn.prop, MOAIProp2D.ATTR_Y_LOC )
    anim:setLink ( 3, curveR, btn.prop, MOAIProp2D.ATTR_Z_ROT )
    anim:setMode ( MOAITimer.NORMAL )
    --anim:setSpan ( 4.0 )
    --anim:setSpeed( 1.0 )

    anim:start ()  
    
    end
   
end

function SplashScreen:showWaitMsg ( )
    self.waitText = gui.TextBox.new
	{
		x = 100, y = -270;
		font = "art/fonts/arial_rnd.fnt",
		color = {1,1,1,1},
		fontSize = 42,
		rect = {-300, 0, 300, 200,},
		text = "WAITING FOR FRIEND...",
		hAlignment = MOAITextBox.LEFT_JUSTIFY, vAlignment = MOAITextBox.CENTER_JUSTIFY;
		YFlip = true,
	}:attach ( self )  

	self.dotShows = 0

	self.timer = Timer.new ( 0.75,
        function ()
            self.dotShows = self.dotShows + 1
			
            if self.dotShows > 3 then
                self.dotShows = 1
            end
			
			local str = "WAITING FOR FRIEND"..string.rep(".",self.dotShows)
			if self.waitText ~= nil then
				self.waitText.prop:setString (  str )
			end
        end
    ):start ( 180 )
end

function SplashScreen:dtor ( )
    for _,p in ipairs(self._btns) do
        p:detach ()
    end
end

function SplashScreen:hide ( )
	local controls = self:getChildren ();
	
	if self.timer ~= nil then
		self.timer:stop ()
		self.timer = nil
	end
	
	local action = nil
	
    for n, p in ipairs(controls) do
        print(n)
		action = p.prop:seekColor ( 0, 0, 0, 0.0, 1.0 )
    end
	
	action:setListener ( MOAIAction.EVENT_STOP, self.hideDone )
    --        action.inputViewInst = self	
	--self:dtor()
	
end

function SplashScreen:hideDone ( )
	print("HIDE DONE")
	app.queue:postEvent ( nil, GameView.E_ANIMATED.SPLASH_DONE, { done = true, })	
end




  
  
  